﻿<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="html"/>
  <xsl:template match="/">
    <xsl:apply-templates select="document" />
    <html>
      <head>
        <title>Benutzer Adressen</title>
      </head>
      <body>
        <h1>
          Benutzer Adressen für <xsl:value-of select="//benutzer/vorname"/>&#160;<xsl:value-of select="//benutzer/nachname"/>
      </h1>
        <table border="2">
          <tr>
            <th>Anschrift</th>
            <th>Vorname</th>
            <th>Nachname</th>
            <th>Straße</th>
            <th>PLZ</th>
            <th>Ort</th>
            <th>Land</th>
          </tr>
          <xsl:apply-templates select="//adressen/adresse" mode="table" />
        </table>
        <p/>
        <xsl:apply-templates select="//adressen/adresse" mode="list" />
      </body>
    </html>
  </xsl:template>

  <xsl:template match="adresse" mode="table" >
    <tr><xsl:apply-templates mode="table" /></tr>      
  </xsl:template>

  <xsl:template match="anschrift|vorname|nachname|straße|plz|ort|land" mode="table" >
    <td>
      <xsl:apply-templates />
    </td>
  </xsl:template>

  <xsl:template match="adresse" mode="list" >
    <p>
      <xsl:value-of select="anschrift"/>&#160;<xsl:value-of select="vorname"/>&#160;<xsl:value-of select="nachname"/>
      <br/>
      <xsl:value-of select="straße"/>
      <br/>
      <xsl:value-of select="plz"/>&#160;<xsl:value-of select="ort"/>
      <br/>
      <xsl:value-of select="land"/>
    </p>
  </xsl:template>

</xsl:stylesheet>
