﻿/// <reference path="../App.js" />

(function () {
    "use strict";

    // Die Initialisierungsfunktion muss bei jedem Laden einer neuen Seite ausgeführt werden.
    Office.initialize = function (reason) {
        $(document).ready(function () {
            app.initialize();

            $('#bereich-auf-basis-Markierung').click(bereichAufBasisMarkierungErstellen);
            $('#liste-verbindungen-anzeigen').click(listeVerbindungenAnzeigen);
            $('#inhalt-Bereich').click(inhaltBereich);
            $('#inhalt-Bereich-RichText').click(inhaltBereichRichText);
            $('#inhalt-HTML').click(inhaltHTML);
        });
    };

    function bereichAufBasisMarkierungErstellen() {
        var input = document.getElementById('inputNeuerBereichName');
        var bindingName = input.value;
        Office.context.document.bindings.addFromSelectionAsync(Office.BindingType.Text,
           { id: bindingName },
            function (result) {
                if (result.status === Office.AsyncResultStatus.Succeeded) {
                    var binding = result.value;
                    var bindingId = binding.id;
                    app.showNotification('Neue Verbindung erstellt:', '"' + binding.type + '"' +
                        '\n' + '"' + bindingId + '"');
                } else {
                    app.showNotification('Fehler:', result.error.message);
                }

            });
    }

    function listeVerbindungenAnzeigen() {
        Office.context.document.bindings.getAllAsync(function (result) {
            var bindingString = '';
            for (var i in result.value) {
                bindingString += result.value[i].id + '\n';
            }
            app.showNotification("Das Dokument enthält die Verbindungen: ", bindingString);
        });
    }

    function inhaltBereich() {
        var input = document.getElementById('inputBereichName');
        var bindingName = input.value;
        var bindingInhalt = "";
        var binding = new Object();
        Office.context.document.bindings.getByIdAsync(bindingName, function (asyncResult) {
            if (asyncResult.status == Office.AsyncResultStatus.Failed) {
                app.showNotification('Ausführung fehlgeschlagen. Fehler: ' +
                    asyncResult.error.message);
            }
            else {
                binding = asyncResult.value;
                binding.getDataAsync(function (result) {
                    if (result.status === Office.AsyncResultStatus.Succeeded) {
                        bindingInhalt = result.value;
                        app.showNotification("Inhalt des Binding" + binding.id + ": ",
                            bindingInhalt)
                    } else {
                        app.showNotification('Fehler:', result.error.message);
                    }
                });
            }
        });
    }

    var bindingCounter = 0;
    function inhaltBereichRichText() {
        var input = document.getElementById('inputRichTextName');
        var bindingName = input.value;
        var bindingInhalt = "";
        var binding = new Object();
        Office.context.document.bindings.addFromNamedItemAsync(bindingName,
            Office.BindingType.Text, { id: 'RT' + bindingCounter },
            function (result) {
                if (result.status == Office.AsyncResultStatus.Succeeded) {
                    bindingCounter++;
                    binding = result.value;
                    binding.getDataAsync(function (result) {
                        if (result.status == Office.AsyncResultStatus.Succeeded) {
                            bindingInhalt = result.value;
                            app.showNotification("Inhalt des neuen Binding ",  binding.id + ": ",
                                      bindingInhalt);
                        } else {
                            app.showNotification('Fehler:', result.error.message);
                        }
                    })
                } else {
                    app.showNotification('Fehler:', result.error.message);
                }
            });
    }

    function inhaltHTML() {
        var input = document.getElementById('inputHTML');
        var htmlContent = input.value;
        var bindingName = "RT1";
        var binding = new Object();
        Office.context.document.bindings.getByIdAsync(bindingName, function (asyncResult) {
            if (asyncResult.status == Office.AsyncResultStatus.Failed) {
                app.showNotification('Ausführung fehlgeschlagen. Fehler: ',
                    asyncResult.error.message);
            }
            else {
                binding = asyncResult.value;
                binding.setDataAsync(htmlContent, { coercionType: 'html' }, function (result) {
                    if (result.status === Office.AsyncResultStatus.Succeeded) {
                        app.showNotification("Daten wurden geschrieben.", "")
                    } else {
                        app.showNotification('Fehler:', result.error.message);
                    }
                });
            }
        });
    }
})();
