<?xml version="1.0" encoding="utf-8" standalone="yes"?>
<xsl:stylesheet 
  version="1.0" 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:s='uuid:BDC6E3F0-6DA3-11d1-A2A3-00AA00C14882'
	xmlns:dt='uuid:C2F41010-65B3-11d1-A29F-00AA00C14882'
 	xmlns:rs="urn:schemas-microsoft-com:rowset"
	xmlns:z="#RowsetSchema"
  xmlns:w="test"
  exclude-result-prefixes="dt rs s z w" >
	<xsl:output method="xml" indent="yes" encoding="utf-8" standalone="yes" version="1.0"/>
  <xsl:decimal-format decimal-separator="," grouping-separator="." />
  <xsl:variable name="kundencode">
    <xsl:choose>
      <xsl:when
        test="//s:ElementType[@name='row']/s:AttributeType[@rs:name='Kunden-Code']">
        <xsl:value-of select="//s:ElementType[@name='row']/s:AttributeType[@rs:name='Kunden-Code']/@name" />
      </xsl:when>
      <xsl:otherwise>Kunden-Code</xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
  <xsl:variable name="bestellnr">
    <xsl:choose>
      <xsl:when
        test="//s:ElementType[@name='rBestellungen']/s:AttributeType[@rs:name='Bestell-Nr']">
        <xsl:value-of select="//s:ElementType[@name='rBestellungen']/s:AttributeType[@rs:name='Bestell-Nr']/@name" />
      </xsl:when>
      <xsl:otherwise>Bestell-Nr</xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
  <xsl:variable name="endpreis">
    <xsl:choose>
      <xsl:when
        test="//s:ElementType[@name='rBestellungen']/s:AttributeType[@rs:name='Endpreis']">
        <xsl:value-of select="//s:ElementType[@name='rBestellungen']/s:AttributeType[@rs:name='Endpreis']/@name" />
      </xsl:when>
      <xsl:otherwise>Endpreis</xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
  <xsl:template match="//xml">
    <xsl:processing-instruction name ="mso-application">
      <xsl:text>progid="Word.Document"</xsl:text>
    </xsl:processing-instruction>
    <w:document>
      <w:a0>Report heading</w:a0>
      <w:b0>
      <xsl:if test="not(//xml/rs:data/z:row)">
        No matching Kunden records
      </xsl:if>
      <xsl:apply-templates select="rs:data/z:row"/>
      </w:b0>
      <w:c0>Report footing</w:c0>
    </w:document>
  </xsl:template>
  <xsl:template match="rs:data/z:row">
    <w:a1>Firma: <xsl:value-of select="@*[local-name()= $kundencode]" />
    </w:a1>
    <xsl:choose>
      <xsl:when test="not(rBestellungen)">
        <w:b1>No matching Bestellungen records</w:b1>       
      </xsl:when>
      <xsl:otherwise>
        <w:b1>
          <xsl:apply-templates select="rBestellungen"/>
        </w:b1>
        <w:c1>
          Gesamtendpreis: <xsl:value-of select="format-number(sum(rBestellungen/@*[local-name()= $endpreis]),'#.##0,00')" />
        </w:c1>
        <w:c1/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="rBestellungen">
    <w:b2>
      Bestell-Nr: <xsl:value-of select="@*[local-name()= $bestellnr]" />
      Endpreis: <xsl:value-of select="format-number(@*[local-name()= $endpreis],'#.##0,00')" />
    </w:b2>
  </xsl:template>
 </xsl:stylesheet>
