Imports Tools = Microsoft.Office.Tools
Imports Word = Microsoft.Office.Interop.Word

Public Class IfFieldBauen

    Private m_doc As Word.Document
    Private m_ctp As Tools.CustomTaskPane
    Private wdApp As Word.Application
    Private m_FeldNamenListe As System.Collections.ArrayList

#Region "Aufgabenbereich"
    'Wird beim Einblenden des Aufgabenbereichs ausgefhrt
    Public Sub IfFieldInitialisieren(ByVal doc As Word.Document, _
      ByVal ctp As Tools.CustomTaskPane)
        m_doc = doc
        m_ctp = ctp
        wdApp = doc.Application
        m_FeldNamenListe = FieldTools.MergeFieldListeHolen(m_doc)

        Me.cboFeldname1.Items.AddRange(m_FeldNamenListe.ToArray())
        Me.cboDann.Items.AddRange(m_FeldNamenListe.ToArray())
        Me.cboSonst.Items.AddRange(m_FeldNamenListe.ToArray())
    End Sub

    'Wird bei der Auswahl eines Feldnamens aus einer Combobox ausgefhrt.
    'Schreibt die Mergefield-Feldfunktion in die passende Textbox,
    'an die Stelle der gegenwrtige Markierung.
    Private Sub cboFeldnamenListe_SelectedIndexChanged(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles cboSonst.SelectedIndexChanged, _
      cboDann.SelectedIndexChanged

        Dim cboActionControl As Windows.Forms.ComboBox = sender
        Dim FeldText As String = MergeFieldText(cboActionControl)
        Select Case cboActionControl.Name
            Case "cboDann"
                Me.txtDann.Text = TextKlauselZusammenstellen(Me.txtDann, FeldText)
            Case "cboSonst"
                Me.txtSonst.Text = TextKlauselZusammenstellen(Me.txtSonst, FeldText)
            Case Else
        End Select
    End Sub

    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        IfFunktionEinfgen()
        ReleaseTaskPane()
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        ReleaseTaskPane()
    End Sub

    Private Sub ReleaseTaskPane()
        m_ctp.Visible = False
        m_ctp = Nothing
        m_doc = Nothing
        wdApp = Nothing
    End Sub
#End Region 'Aufgabenbereich

#Region "If-Feldfunktion erstellen"
    Private Function TextKlauselZusammenstellen(ByVal control As Windows.Forms.TextBox, _
      ByVal FeldText As String) As String
        Dim sel As Integer, allText As String = ""
        sel = control.SelectionStart
        allText = control.Text
        If sel > 1 Then
            allText = allText.Substring(0, sel - 1) & FeldText & allText.Substring(sel)
        Else
            allText = FeldText & allText.Substring(sel)
        End If
        Return allText
    End Function

    'Stellt den Text fr die MergeField-Feldfunktion zusammen.
    Private Function MergeFieldText(ByVal ActionControl As Windows.Forms.Control) As String
        Dim fldText As String = ""

        Try
            fldText = "{ MergeField " & ActionControl.Text & " }"
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
        Return fldText
    End Function

    'Fgt die If-Feldfunktion an die Stelle der gegenwrtigen Markierung
    'des aktiven Dokuments ein.
    Sub IfFunktionEinfgen()
        Dim strTeststrFeldCode As String
        Dim rngTarget As Word.Range

        rngTarget = wdApp.Selection.Range
        strTeststrFeldCode = IfFeldCodeZusammensetzen()
        'MessageBox.Show(strTeststrFeldCode)
        rngTarget = FieldTools.FeldCodeEinfuegen(strTeststrFeldCode, rngTarget)
        rngTarget.Fields.Update()
    End Sub

    'Stellt die vollstndige Zeichenkette fr die If-Feldfunktion
    'aus den verschiedenen Teilen zusammen.
    Function IfFeldCodeZusammensetzen() As String
        Dim feldCode As String = ""

        Try
            feldCode = "{ If " & Chr(34) & "{ Mergefield " & Me.cboFeldname1.Text & " }" & Chr(34) & " " _
              & VergleichSymbolHolen(Me.cboVergleich.Text) & " " & Chr(34) & _
              Me.txtVergleichenMit.Text & Chr(34) & " " & Chr(34) & _
              Me.txtDann.Text & Chr(34) & " " & Chr(34) & Me.txtSonst.Text & Chr(34) & " }"
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try

        Return feldCode
    End Function

    Private Function VergleichSymbolHolen(ByVal symbol As String) As String
        Dim symbolChar As String = ""
        Select Case symbol
            Case "Gleich"
                symbolChar = "="
            Case "Ungleich"
                symbolChar = "<>"
            Case "Grer als"
                symbolChar = ">"
            Case "Kleiner als"
                symbolChar = "<"
            Case "Kleiner oder gleich"
                symbolChar = "<="
            Case "Grer oder gleich"
                symbolChar = ">="
            Case "Ist leer"
                symbolChar = "=''"
            Case "Ist nicht leer"
                symbolChar = "<>''"
            Case Else
        End Select
        Return symbolChar
    End Function

#End Region 'If-Feldfunktion erstellen
End Class

'Allgemeine Werkzeuge fr die Arbeit mit dem Feldfunktionen und den Seriendruck
Public Class FieldTools

    'Erstellt eine Liste der Feldnamen der gegenwrtige Datenquelle
    Public Shared Function MergeFieldListeHolen(ByVal doc As Word.Document) As ArrayList
        Dim Liste As ArrayList = New ArrayList
        Dim sd As Word.MailMerge
        Dim fld As Word.MailMergeFieldName

        Try
            sd = doc.MailMerge
            If sd.MainDocumentType = Word.WdMailMergeMainDocType.wdNotAMergeDocument Then
                Exit Try
            End If
            For Each fld In sd.DataSource.FieldNames
                Liste.Add(fld.Name)
            Next
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try

        Return Liste
    End Function

    Public Shared Function FeldCodeEinfuegen(ByVal strFeldCode As String, _
      ByRef rngZielBereich As Word.Range) As Word.Range

        ' Zweck:-
        ' Wandelt Text in Feldcodes um, wo:
        ' "{" bedeutet eine ffnende Feldklammer
        ' "}" bedeutet eine schlieende Feldklammer
        ' "{" bedeutet eine normale, ffnende, geschweifte Klammer
        ' "}" bedeutet eine normale, schlieende, geschweifte Klammer
        ' "" bedeutet ein  Zeichen
        ' "" gefolgt von anderen Zeichen wird verworfen

        ' Parameter:-
        ' strFeldCode: die Zeichenkette, die den Feldcode definiert
        ' ZielBereich: wo die Feldfunktion einzufgen ist

        Const EscapeChar As String = ""
        Dim lIndex As Long
        Dim bEscapeCharFound As Boolean
        Dim sBuffer As String
        Dim sChar As String
        Dim rngStart As Word.Range
        bEscapeCharFound = False
        sBuffer = ""
        rngStart = rngZielBereich.Duplicate

        rngZielBereich.TextRetrievalMode.IncludeFieldCodes = True
        For lIndex = 1 To Len(strFeldCode)
            sChar = Mid(strFeldCode, lIndex, 1)
            Select Case sChar
                Case EscapeChar
                    If bEscapeCharFound Then
                        sBuffer = sBuffer + sChar
                        bEscapeCharFound = False
                    Else
                        bEscapeCharFound = True
                    End If
                Case "{"
                    If bEscapeCharFound Then
                        sBuffer = sBuffer + sChar
                        bEscapeCharFound = False
                    Else
                        ' Wir sind am Anfang einer Feldfunktion angelangt.
                        rngZielBereich.Text = sBuffer
                        sBuffer = ""
                        rngZielBereich.Collapse(Direction:=Word.WdCollapseDirection.wdCollapseEnd)
                        rngZielBereich.Fields.Add(Range:=rngZielBereich, Type:=Word.WdFieldType.wdFieldEmpty, _
                          Text:="", PreserveFormatting:=False)
                        rngZielBereich.SetRange(Start:=rngZielBereich.Start + 1, _
                          End:=rngZielBereich.Start + 1)
                        rngZielBereich.Delete(Unit:=Word.WdUnits.wdCharacter, Count:=2)
                    End If
                Case "}"
                    If bEscapeCharFound Then
                        sBuffer = sBuffer + sChar
                        bEscapeCharFound = False
                    Else
                        ' Wir sidn am Ende einer Feldfunktion angelangt.
                        rngZielBereich.InsertAfter(Text:=sBuffer)
                        rngZielBereich.Select()
                        sBuffer = ""
                        rngZielBereich.Collapse(Direction:=Word.WdCollapseDirection.wdCollapseEnd)
                        rngZielBereich.SetRange(Start:=rngZielBereich.End + 1, _
                          End:=rngZielBereich.End + 1)
                    End If
                Case Else
                    sBuffer = sBuffer + sChar
            End Select
        Next
        rngZielBereich.InsertAfter(Text:=sBuffer)
        rngZielBereich.Start = rngStart.Start
        FeldCodeEinfuegen = rngZielBereich
    End Function
End Class