using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using forms = System.Windows.Forms;
using System.Reflection;
//zustzliche Deklarationen am Projektanfang
using wd = Microsoft.Office.Interop.Word;
using wdMarschal = System.Runtime.InteropServices.Marshal;

namespace Kap07_CS
{
	/// <summary>
	/// Zusammenfassung fr Kap06Bookmark.
	/// </summary>
	public class Kap07Bookmark : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button Schliessen;
		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button Listing_VordefinierteTextmarken;
		private System.Windows.Forms.Button Listing7_2;
		private System.Windows.Forms.Button Listing7_4;

		private wd.Application wdApp ;

		public Kap07Bookmark(wd.Application WdApp)
		{
			//
			// Erforderlich fr die Windows Form-Designeruntersttzung
			//
			InitializeComponent();
			wdApp = WdApp;
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
            this.Schliessen = new System.Windows.Forms.Button();
            this.Listing7_2 = new System.Windows.Forms.Button();
            this.Listing7_4 = new System.Windows.Forms.Button();
            this.Listing_VordefinierteTextmarken = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // Schliessen
            // 
            this.Schliessen.Location = new System.Drawing.Point(272, 16);
            this.Schliessen.Name = "Schliessen";
            this.Schliessen.Size = new System.Drawing.Size(128, 32);
            this.Schliessen.TabIndex = 3;
            this.Schliessen.Text = "Schlieen";
            this.Schliessen.Click += new System.EventHandler(this.Schliessen_Click);
            // 
            // Listing7_2
            // 
            this.Listing7_2.Location = new System.Drawing.Point(40, 16);
            this.Listing7_2.Name = "Listing7_2";
            this.Listing7_2.Size = new System.Drawing.Size(192, 32);
            this.Listing7_2.TabIndex = 4;
            this.Listing7_2.Text = "Listing 7.2 Textmarke hinzufgen";
            this.Listing7_2.Click += new System.EventHandler(this.Listing7_2_Click);
            // 
            // Listing7_4
            // 
            this.Listing7_4.Location = new System.Drawing.Point(40, 72);
            this.Listing7_4.Name = "Listing7_4";
            this.Listing7_4.Size = new System.Drawing.Size(192, 32);
            this.Listing7_4.TabIndex = 5;
            this.Listing7_4.Text = "Listing 7.4 Daten in Textmarken eingeben";
            this.Listing7_4.Click += new System.EventHandler(this.Listing7_4_Click);
            // 
            // Listing_VordefinierteTextmarken
            // 
            this.Listing_VordefinierteTextmarken.Location = new System.Drawing.Point(40, 128);
            this.Listing_VordefinierteTextmarken.Name = "Listing_VordefinierteTextmarken";
            this.Listing_VordefinierteTextmarken.Size = new System.Drawing.Size(192, 32);
            this.Listing_VordefinierteTextmarken.TabIndex = 6;
            this.Listing_VordefinierteTextmarken.Text = "Vordefinierte Textmarken Beispiel (keine Listing im Buch)";
            this.Listing_VordefinierteTextmarken.Click += new System.EventHandler(this.Listing_VordefinierteTextmarken_Click);
            // 
            // Kap07Bookmark
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(424, 198);
            this.Controls.Add(this.Listing_VordefinierteTextmarken);
            this.Controls.Add(this.Listing7_4);
            this.Controls.Add(this.Listing7_2);
            this.Controls.Add(this.Schliessen);
            this.Name = "Kap07Bookmark";
            this.Text = "Kapitel 7 Bookmark Code Beispiele";
            this.ResumeLayout(false);

		}
		#endregion

		#region Listing 7_2
		private void Listing7_2_Click(object sender, System.EventArgs e)
		{
			TextmarkeEinfuegen_CS();
		}

		private void TextmarkeEinfuegen_CS()
		{
			string text = "";
			string markierungTyp = "";
            object missing = System.Type.Missing;
            if (wdApp.Documents.Count < 1)
            {
                wdApp.Documents.Add(ref missing, ref missing, ref missing, ref missing);
            }
			wd.Selection sel = wdApp.Selection;
			wd.Range rng = sel.Range;
			//Maximal 30 Zeichen werden in der Eingabeaufforderung angezeigt.
			//Sind es mehr, schneiden wir ihn ab und fgen ... hinzu.
			string rngText = "";
			rngText = rng.Text;
			//In C# wird keine Markierung als Null interpretiert.
			if (rngText == null || rngText.Length <= 30)
			{
				text = rng.Text;
			}
			else
			{
				text = rng.Text.Substring(1, 30) + "...";
			}
  
			//Die Eingabeaufforderung unterscheidet, ob Zeichen markiert sind.
			if (sel.Type == wd.WdSelectionType.wdSelectionIP)
			{
				markierungTyp = "die markierte Position im Dokument";
			}
			else if (sel.Type == wd.WdSelectionType.wdSelectionNormal)
			{
				markierungTyp = "den markierten Text \"" + text + "\"";
			}
			else
			{
				forms.MessageBox.Show("Sie knnen an diese Stelle keine Textmarke einfgen");
				goto Ende;
			}

			//Formular fr die Eingabeaufforderung einblenden
			string textmarkenname = BenutzerEingabe(markierungTyp);
			try
			{
				if (textmarkenname.Length > 0)
				{
					object objRange = rng;
					wdApp.ActiveDocument.Bookmarks.Add(textmarkenname, ref objRange);
				}
			}
			catch (System.Exception ex)
			{
				forms.MessageBox.Show(ex.Message + "\n" + ex.Source + "\n" + ex.InnerException);
			}
			Ende: text="";
		}

		//Das Formular fr die Benuztereingabe erstellen und anzeigen
		forms.Form frm;
		private string BenutzerEingabe(string zusatzText)
		{
			frm = new forms.Form();
			frm.Size = new System.Drawing.Size(300, 180);

			forms.TextBox inputBox = new forms.TextBox();
			inputBox.Location = new System.Drawing.Point(10, 40);
			inputBox.Size = new System.Drawing.Size(200, 15);
			
			forms.Label label = new forms.Label();
			label.Location = new System.Drawing.Point(10, 10);
			label.Size = new System.Drawing.Size(280, 30);
			label.Text = "Bitte geben Sie der Textmarke fr " + zusatzText + " einen Namen:";

			forms.Button btnSchliessen = new forms.Button();
			btnSchliessen.Text = "Schlieen";
			btnSchliessen.Location = new System.Drawing.Point(10, 70);
			btnSchliessen.Size = new System.Drawing.Size(100, 20);
			btnSchliessen.Click += new System.EventHandler(btnSchliessen_Click);

			frm.Controls.Add(inputBox);
			frm.Controls.Add(label);
			frm.Controls.Add(btnSchliessen);
			frm.ShowDialog();

			return inputBox.Text;
		}
		private void btnSchliessen_Click(object sender, System.EventArgs e)
		{
			frm.Hide();
		}
		#endregion Listing 7_2

		#region Listing 7_4
		private void Listing7_4_Click(object sender, System.EventArgs e)
		{
			DatenEingeben_CS();
		}

		private void DatenEingeben_CS()
		{
			object objMissing = System.Reflection.Missing.Value;
			string text = "NEUER TEXT";
			string dateiName = System.IO.Directory.GetCurrentDirectory();
			System.IO.DirectoryInfo di = new System.IO.DirectoryInfo(dateiName);
			object objDateiName = (object) (di.Parent.Parent.Parent.FullName + "\\Bsp07_01_Bookmark.docm");
			wd.Document doc = wdApp.Documents.Open(ref objDateiName,
				ref objMissing, ref objMissing, ref objMissing, ref objMissing, ref objMissing, 
				ref objMissing, ref objMissing, ref objMissing, ref objMissing, ref objMissing,
				ref objMissing, ref objMissing, ref objMissing, ref objMissing, ref objMissing);
			string textmarkenName = "TM1";
			//Neuen Text am Anfang des Textmarkeninhalts einfgen.
			object objBookmarkName = textmarkenName;
			wd.Bookmark bkm = doc.Bookmarks.get_Item(ref objBookmarkName);
			bkm.Range.InsertBefore(text);
    
			textmarkenName = "TM2";
			objBookmarkName = textmarkenName;
			bkm = doc.Bookmarks.get_Item(ref objBookmarkName);
			//Neuen Text an die Position der Textmarke einfgen.
			bkm.Range.Text = text;
    
			bkm=null;
			textmarkenName = "TM3";
			objBookmarkName = textmarkenName;
			//Den gegenwrtigen Inhalt mit neuem Text ersetzen und Textmarke beibehalten.
			//Prfen, ob die Textmarke vorhanden ist
			if (doc.Bookmarks.Exists(textmarkenName))
			{
				bkm = doc.Bookmarks.get_Item(ref objBookmarkName);
				wd.Range rng = bkm.Range;
				rng.Text = text;
				//Die Textmarke ist weg und muss ersetzt werden
				object objRange = rng;
				bkm = doc.Bookmarks.Add(textmarkenName, ref objRange);
			}
		}
		#endregion Listing 7_4

		#region vordefinierte Textmarken
		private void Listing_VordefinierteTextmarken_Click(object sender, System.EventArgs e)
		{
			bool bFound; 
			object objMissing = System.Reflection.Missing.Value;
			object objFalse = false;
			object objTrue = true;
			object objCollapseStart = wd.WdCollapseDirection.wdCollapseStart;
			object objCollapseEnd = wd.WdCollapseDirection.wdCollapseEnd;
			if (wdApp.Documents.Count > 0)
			{
				wd.Range rngSuchBereich = wdApp.ActiveDocument.Content;
				wd.Document docNeu = wdApp.Documents.Add(ref objMissing, ref objMissing, ref objMissing, ref objMissing);
				wd.Range rngZielBereich = docNeu.Content;
				//Am Dokumentanfang beginnen
				rngSuchBereich.Collapse(ref objCollapseStart);
				rngSuchBereich.Select();
				wdApp.ScreenUpdating = false;
				object objWrap = (object) wd.WdFindWrap.wdFindStop;
				object objStyle = (object)wd.WdBuiltinStyle.wdStyleHeading3;
				wdApp.Selection.Find.set_Style(ref objStyle);
				do
				{
					bFound = wdApp.Selection.Find.Execute(ref objMissing, ref objFalse, ref objFalse,
						ref objFalse, ref objFalse, ref objFalse, ref objTrue, ref objWrap, ref objTrue, 
						ref objMissing, ref objMissing, ref objMissing, ref objMissing, ref objMissing, ref objMissing);
					if (bFound)
					{
						object objTextmarke = "\\HeadingLevel";
						wd.Bookmark bkm = wdApp.Selection.Bookmarks.get_Item(ref objTextmarke);
						rngZielBereich.FormattedText = bkm.Range.FormattedText;
						rngZielBereich.Collapse(ref objCollapseEnd);
						wdApp.Selection.Collapse(ref objCollapseEnd);
					}
				} while (bFound);
				wdApp.ScreenUpdating = true;
				docNeu.Activate();
			}
		}

		#endregion vordefinierte Textmarken

        private void Schliessen_Click(object sender, System.EventArgs e)
		{
			this.Hide();
		}

	}
}
