using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Diagnostics;
using System.Runtime.InteropServices;
using wd = Microsoft.Office.Interop.Word;

namespace Kap10_CS
{
    public partial class Kap10_Formular : Form
    {
        public Kap10_Formular()
        {
            InitializeComponent();
        }

        wd.Application wdApp;
        Process pcs;
        object missing = System.Reflection.Missing.Value;
        object objTrue = true;

        private void btnWordStart_1_Click(object sender, EventArgs e)
        {
            if (GetWordInstance_1())
            {
                try
                {
                    wdApp.ActiveWindow.WindowState = Microsoft.Office.Interop.Word.WdWindowState.wdWindowStateMaximize;
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
        }

        private void btnWordStart_2_Click(object sender, EventArgs e)
        {
            wd.Document wdDoc;
            if (GetWordInstance_2())
            {
                try
                {
                    wdApp.Visible = true;
                    wdDoc = wdApp.Documents.Add(ref missing, ref missing, ref missing, ref objTrue);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
        }

        private bool GetWordInstance_1()
        {
            bool retVal = false;
            try
            {
                Process[] wdPcs = Process.GetProcessesByName("WinWord");
                if (wdPcs.Length > 0)
                {
                    pcs = wdPcs[0];
                    wdApp = (wd.Application)Marshal.GetActiveObject("Word.Application");
                }
                if (wdApp == null)
                {
                    Process wdProcess = Process.Start("winword.exe");
                    Timer t = new Timer();
                    t.Start();
                    while (wdApp == null && (t.Interval < 10000))
                    {
                        try
                        {
                            //Es braucht Zeit, bis die Anwendung luft und angesprochen werden kann.
                            wdApp = (wd.Application)Marshal.GetActiveObject("Word.Application");
                        }
                        catch { }
                    }
                    t.Stop();
                    t = null;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                if (wdApp != null) retVal = true;
            }
            return retVal;
        }

        private bool GetWordInstance_2()
        {
            bool retVal = false;
            try
            {
                Process[] wdPcs = Process.GetProcessesByName("WinWord");
                if (wdPcs.Length > 0)
                {
                    pcs = wdPcs[0];
                    wdApp = (wd.Application)Marshal.GetActiveObject("Word.Application");
                }
                if (wdApp == null)
                {
                    //Die folgende Zeile startet Word und weist es der wdApp-Variabel zu
                    wdApp = new wd.Application();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                if (wdApp != null) retVal = true;
            }
            return retVal;
        }

        private void btnWordFreigeben_Click(object sender, System.EventArgs e)
        {
            try
            {
                //Auf der Klassenebene deklarierte Variablen freigeben
                wdApp = null;
            }
            catch
            {
            }
            finally
            {
                GC.Collect();
                GC.WaitForPendingFinalizers();
                GC.Collect();
                GC.WaitForPendingFinalizers();
                //Application.Exit();
            }
        }

        private void btnWordBeenden_Click(object sender, EventArgs e)
        {
            try
            {
                //Speicheraufforderung bei Bedarf einblenden lassen
                object objPromptSaveChanges = wd.WdSaveOptions.wdPromptToSaveChanges;
                wdApp.Quit(ref objPromptSaveChanges, ref missing,ref missing);
            }
            catch
            {
            }
            try
            {   //Auf der Klassenebene deklarierte Variablen freigeben
                wdApp = null;
            }
            catch { }
            finally
            {
                GC.Collect();
                GC.WaitForPendingFinalizers();
                GC.Collect();
                GC.WaitForPendingFinalizers();
                //Application.Exit();
            }
        }

        private void btnSchlieen_Click(object sender, EventArgs e)
        {
            this.Close();
        }


}
}

