﻿Imports VSTA = Microsoft.VisualStudio.Tools.Applications
Imports System.Xml.Serialization
Imports System.IO
Imports System.Windows.Forms

Public Class DatenCacheLesen

    Private Sub btnDatenCacheLesen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDatenCacheLesen.Click
        Dim dokName As String = Me.txtDokumentName.Text
        Dim dokPfad As String
        If dokName.Length > 0 Then
            dokPfad = System.Environment.GetFolderPath( _
             Environment.SpecialFolder.MyDocuments) & "\" & dokName
        Else
            MessageBox.Show("Bitte einen Dateinamen eingeben.")
            Return
        End If

        If File.Exists(dokPfad) Then
            Try
                Dim serverDok As New VSTA.ServerDocument(dokPfad)
                Dim datenAusDemCache As VSTA.CachedData = serverDok.CachedData
                Dim datenHostItems As VSTA.CachedDataHostItemCollection = _
                  datenAusDemCache.HostItems
                Dim datenHostItem As VSTA.CachedDataHostItem
                Dim datenPunkt As VSTA.CachedDataItem
                Dim cachedInhalt As String = ""
                For Each datenHostItem In datenHostItems
                    For Each datenPunkt In datenHostItem.CachedData
                        'Schreibt das rohe XML 
                        System.Diagnostics.Debug.Print(vbTab & datenPunkt.Id & ": " & datenPunkt.Xml)
                        cachedInhalt = cachedInhalt & datenPunkt.Id & ": " & ExtractTextAusXML(datenPunkt.Xml) & vbCrLf
                    Next
                Next
                'Zeigt den Dateninhalt im Fenster an
                Me.txtDaten.Text = cachedInhalt
                serverDok.Close()
            Catch ex As Exception
                MessageBox.Show(ex.Message)
            End Try
        Else
            MessageBox.Show("Das Dokument " & dokPfad & _
                " konnte nicht gefunden werden.")
        End If
    End Sub

    Private Function ExtractTextAusXML(ByVal inhalt As String) As String
        Dim inhaltText As String
        Dim xmlDoc As Xml.XmlDocument = New Xml.XmlDocument
        xmlDoc.LoadXml(inhalt)
        inhaltText = xmlDoc.LastChild.InnerText
        Return inhaltText
    End Function
End Class
