﻿Imports System.IO
Imports DocumentFormat.OpenXml

Public Class OpenXMLSDK_02
    'Globale Variablen
    Dim startPfad As String = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments)
    Dim meldung As String = ""
    Dim dateiWurdeBearbeitet As Boolean = True

    Private Sub btnTeileKopieren_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTeileKopieren.Click
        Dim sPfadQuelle As String = Me.txtQuelle_Pfad.Text
        Dim sPfadZiel As String = Me.txtZiel_Pfad.Text
        Dim DokTyp As WordprocessingDocumentType = Nothing
        Dim istMakroTyp As Boolean = False

        'Informationsfeld in der Form zurücksetzen.
        meldung = ""
        txtMeldungen.Text = meldung

        'Das Quelle-Dokument öffnen.
        Using pkgDokQuelle As WordprocessingDocument = WordprocessingDocument.Open(sPfadQuelle, False)
            If pkgDokQuelle.DocumentType <> WordprocessingDocumentType.MacroEnabledDocument And
                pkgDokQuelle.DocumentType <> WordprocessingDocumentType.MacroEnabledTemplate Then
                txtMeldungen.Text = "Das Quelle-Dokument enthält keine Makros. Es ist keine *.docm oder *.dotm Datei."
                Exit Sub
            End If
            'Die Quellenteile, die kopiert werden.
            Dim partRibbon2007Quelle As RibbonExtensibilityPart = pkgDokQuelle.RibbonExtensibilityPart
            Dim partRibbon2010Quelle As RibbonAndBackstageCustomizationsPart = pkgDokQuelle.RibbonAndBackstageCustomizationsPart
            Dim partMainDokQuelle As MainDocumentPart = pkgDokQuelle.MainDocumentPart
            Dim partVbaBinQuelle As VbaProjectPart = partMainDokQuelle.VbaProjectPart
            'Das Ziel-Dokument bearbeiten.
            Using pkgDokZiel As WordprocessingDocument = WordprocessingDocument.Open(sPfadZiel, True)
                DokTyp = pkgDokZiel.DocumentType
                istMakroTyp = FuerMakrosBefaehigen(pkgDokZiel, DokTyp)

                If Not partRibbon2007Quelle Is Nothing Then
                    If Not Ribbon2007Ersetzen(pkgDokZiel, partRibbon2007Quelle) Then Exit Sub
                End If
                If Not partRibbon2010Quelle Is Nothing Then
                    If Not Ribbon2010Ersetzen(pkgDokZiel, partRibbon2010Quelle) Then Exit Sub
                End If
                If Not partVbaBinQuelle Is Nothing Then
                    If Not VbaProjectErsetzen(pkgDokZiel, partVbaBinQuelle) Then Exit Sub
                End If
            End Using
        End Using
        'Das Zieldatei bei Bedarf umbenennen.
        If Not istMakroTyp And dateiWurdeBearbeitet Then
            DateiEndungAnpassen(DokTyp, sPfadZiel)
        End If
        meldung = "Die Bearbeitung des Dokuments wurde erfolgreich abgeschlossen! " & meldung
        txtMeldungen.Text = meldung
    End Sub

    Private Function Ribbon2007Ersetzen(ByVal pkg As WordprocessingDocument, _
                                        ByVal partQuelle As RibbonExtensibilityPart) As Boolean
        Dim weiterfahren As Boolean = True
        Dim ersetzt As String = ""
        Dim input As DialogResult

        Dim partRibbon2007Ziel As RibbonExtensibilityPart = pkg.RibbonExtensibilityPart
        If Not partRibbon2007Ziel Is Nothing And Not partQuelle Is Nothing Then
            input = MessageBox.Show("Das Ziel Dokument enthält bereits ein Ribbon für Version 2007. Wollen Sie es trotzdem ersetzen?", "Ribbon & VBA kopieren", MessageBoxButtons.YesNoCancel)
            Select Case input
                Case DialogResult.Yes
                    partRibbon2007Ziel.FeedData(partQuelle.GetStream())
                    meldung = meldung & "Das 2007 Menüband wurde ersetzt. "
                Case DialogResult.No
                    dateiWurdeBearbeitet = False
                    meldung = meldung & "Das 2007 Menüband wurde auf Wunsch des Benutzers nicht ersetzt. "
                Case DialogResult.Cancel
                    dateiWurdeBearbeitet = False
                    txtMeldungen.Text = "Der Vorgang wurde abgebrochen, weil das 2007 Menüband nicht ersetzt werden sollte. "
                    weiterfahren = False
                Case Else
            End Select
        ElseIf partRibbon2007Ziel Is Nothing Then
            partRibbon2007Ziel = pkg.AddRibbonExtensibilityPart()
            partRibbon2007Ziel.FeedData(partQuelle.GetStream())
        End If

        Return weiterfahren
    End Function

    Private Function Ribbon2010Ersetzen(ByVal pkg As WordprocessingDocument, ByVal partQuelle As RibbonAndBackstageCustomizationsPart) As Boolean
        Dim weiterfahren As Boolean = True
        Dim ersetzt As String = ""
        Dim input As DialogResult

        Dim partRibbon2010Ziel As RibbonAndBackstageCustomizationsPart = pkg.RibbonAndBackstageCustomizationsPart
        If Not partRibbon2010Ziel Is Nothing Then
            input = MessageBox.Show("Das Ziel Dokument enthält bereits ein Ribbon für Version 2010. Wollen Sie es trotzdem ersetzen?", "Ribbon & VBA kopieren", MessageBoxButtons.YesNoCancel)
            Select Case input
                Case DialogResult.Yes
                    partRibbon2010Ziel.FeedData(partQuelle.GetStream())
                    meldung = meldung & "Das 2010 Menüband wurde ersetzt. "
                Case DialogResult.No
                    dateiWurdeBearbeitet = False
                    meldung = meldung & "Das 2010 Menüband wurde auf Wunsch des Benutzers nicht ersetzt. "
                Case DialogResult.Cancel
                    dateiWurdeBearbeitet = False
                    txtMeldungen.Text = "Der Vorgang wurde abgebrochen, weil das 2010 Menüband nicht ersetzt werden sollte. "
                    weiterfahren = False
                Case Else
            End Select
        ElseIf partRibbon2010Ziel Is Nothing And Not partQuelle Is Nothing Then
            partRibbon2010Ziel = pkg.AddRibbonAndBackstageCustomizationsPart()
            partRibbon2010Ziel.FeedData(partQuelle.GetStream())
        End If

        Return weiterfahren
    End Function

    Private Function VbaProjectErsetzen(ByVal pkg As WordprocessingDocument, ByVal partQuelle As VbaProjectPart) As Boolean
        Dim weiterfahren As Boolean = True
        Dim ersetzt As String = ""
        Dim input As DialogResult

        Dim partMainDokZiel As MainDocumentPart = pkg.MainDocumentPart
        Dim partVbaBinZiel As VbaProjectPart = partMainDokZiel.VbaProjectPart
        Dim partVbaDataQuelle As VbaDataPart = partQuelle.VbaDataPart
        Dim partVbaDataZiel As VbaDataPart = Nothing
        If Not partVbaBinZiel Is Nothing Then
            input = MessageBox.Show("Das Ziel Dokument enthält bereits ein VBA-Projekt. Wollen Sie es trotzdem ersetzen?", "Ribbon & VBA kopieren", MessageBoxButtons.YesNoCancel)
            Select Case input
                Case DialogResult.Yes
                    partVbaBinZiel.FeedData(partQuelle.GetStream())
                    'Wenn Code sich in der Klasse ThisDocument des Quelle-Dokuments befindet,
                    If Not partVbaDataQuelle Is Nothing Then
                        'Braucht es auch im Ziel-Dokument den entsprechenden Teil.
                        partVbaDataZiel = partVbaBinZiel.VbaDataPart
                        If partVbaDataZiel Is Nothing Then
                            partVbaDataZiel = partVbaBinZiel.AddNewPart(Of VbaDataPart)()
                        End If
                        partVbaDataZiel.FeedData(partVbaDataQuelle.GetStream())
                    End If
                    meldung = meldung & "Das VBA Projekt wurde ersetzt. "
                Case DialogResult.No
                    dateiWurdeBearbeitet = False
                    meldung = meldung & "Das VBA Projekt wurde auf Wunsch des Benutzers nicht ersetzt. "
                Case DialogResult.Cancel
                    dateiWurdeBearbeitet = False
                    txtMeldungen.Text = "Der Vorgang wurde abgebrochen, weil das VBA Projekt nicht ersetzt werden sollte. "
                    weiterfahren = False
                Case Else
            End Select
        ElseIf partVbaBinZiel Is Nothing Then
            partVbaBinZiel = pkg.MainDocumentPart.AddNewPart(Of VbaProjectPart)()
            partVbaBinZiel.FeedData(partQuelle.GetStream())
            If Not partVbaDataQuelle Is Nothing Then
                partVbaDataZiel = partVbaBinZiel.AddNewPart(Of VbaDataPart)()
                partVbaDataZiel.FeedData(partVbaDataQuelle.GetStream())
            End If
        End If

        Return weiterfahren
    End Function

    Private Function FuerMakrosBefaehigen(ByVal pkg As WordprocessingDocument, ByVal DokTyp As WordprocessingDocumentType) As Boolean
        Dim makroTyp As Boolean = True
        Select Case DokTyp
            Case WordprocessingDocumentType.Document
                pkg.ChangeDocumentType(WordprocessingDocumentType.MacroEnabledDocument)
                makroTyp = False
            Case WordprocessingDocumentType.Template
                pkg.ChangeDocumentType(WordprocessingDocumentType.MacroEnabledTemplate)
                makroTyp = False
            Case Else
        End Select
        Return makroTyp
    End Function

    Private Sub DateiEndungAnpassen(ByVal DokTyp As WordprocessingDocumentType, ByVal sPfadZiel As String)
        Dim endung As String = ""
        If DokTyp = WordprocessingDocumentType.Document Then
            endung = "docm"
        ElseIf DokTyp = WordprocessingDocumentType.Template Then
            endung = "dotm"
        End If
        Dim neuerName As String = Path.ChangeExtension(sPfadZiel, endung)
        If File.Exists(neuerName) Then
            MessageBox.Show("Der Dateiname " & neuerName & " ist schon vorhanden. Sie müssen die Ziel-Datei manuell in *.docm bzw. *.dotm umbenennen.")
        Else
            Dim f As FileInfo = New FileInfo(sPfadZiel)
            f.MoveTo(neuerName)
            meldung = meldung & "Die Ziel-Datei wurde in " & neuerName & " umbenannt. "
        End If
    End Sub
    Private Sub btnDurchsuchenQuelle_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDurchsuchenQuelle.Click
        Dim sPfad As String = GetDateiPfad()
        txtMeldungen.Text = ""
        If sPfad.Length > 0 Then
            Me.txtQuelle_Pfad.Text = sPfad
        Else
            txtMeldungen.Text = "Keine Quelldatei wurde ausgewählt!"
        End If
    End Sub

    Private Sub btnDurchsuchenZiel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDurchsuchenZiel.Click
        Dim sPfad As String = GetDateiPfad()
        txtMeldungen.Text = ""
        If sPfad.Length > 0 Then
            Me.txtZiel_Pfad.Text = sPfad
        Else
            txtMeldungen.Text = "Keine Zieldatei wurde ausgewählt!"
        End If
    End Sub

    Private Function GetDateiPfad()
        'Sie müssen System.IO importieren
        Dim f As OpenFileDialog = New OpenFileDialog()
        f.Title = "Officedatei auswählen"
        f.InitialDirectory = startPfad
        f.Filter = "Word Dokumente (*.docx;*.docm;*.dotx;*.dotm)|*.docx;*.docm;*.dotx;*.dotm|Excel Arbeitsmappen (*.xlsx;*.xlsm;*.xltx;*.xltm)|*.xlsx;*.xlsm;*.xltx;*.xltm|PowerPoint Präsentationen (*.pptx;*.pptm*;.potx*;.potm)|*.pptx*;.pptm*;.potx*;.potm"
        If f.ShowDialog() <> Windows.Forms.DialogResult.Cancel Then
            'Sorgt dafür, dass währende der Sitzung das Dialogfeld mit diesem Ordner anfängt.
            startPfad = Path.GetDirectoryName(f.FileName)
            Return f.FileName
        Else
            Return String.Empty
        End If
        f = Nothing
    End Function

    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        Me.Close()
    End Sub

End Class