﻿Imports System.Text
Imports DocumentFormat.OpenXml.Drawing

Public Class OpenXMLSDK_03

    Dim m_FilePath As String = "C:\Beispiele\Kap24\Bsp24_01.docx"
    Dim m_TempXmlPath As String = System.IO.Path.Combine(Environment.GetEnvironmentVariable("Temp"), "Bsp23_doc.xml")
    Dim m_w_Namespace As String = "xmlns:w=" & """http://schemas.openxmlformats.org/wordprocessingml/2006/main"""
    Dim m_HtmlStartTR As String = "<tr valign='top' >", endTR As String = "</tr>"
    Dim m_HtmlStartTD As String = "<td width='30%' >", endTD As String = "</td>"
    Dim m_HtmlStart As String = "<html><body>"
    Dim m_HtmlStartTable As String = "<table><tr><td><b>Formatvorlage</b></td><td><b>Definition</b></td></tr>"
    Dim m_HtmlEnd As String = "</body></html>"

    Private Sub btnDokXML_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDokXML.Click
        Dim temp As System.IO.FileInfo = New System.IO.FileInfo(m_TempXmlPath)
        If temp.Exists Then temp.Delete()
        Try
            Using pkgWordDok As WordprocessingDocument = WordprocessingDocument.Open(m_FilePath, False)
                Dim wordMainDok As MainDocumentPart = pkgWordDok.MainDocumentPart
                Dim wordDok As Document = wordMainDok.Document
                XML_DateiErstellen(temp, wordDok)
            End Using
            temp = Nothing
            Me.wbDokumentInhalt.Navigate(m_TempXmlPath)
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub XML_DateiErstellen(ByVal temp As IO.FileInfo, ByVal wordDok As Document)
        Dim sw As System.IO.StreamWriter = temp.AppendText()
        sw.WriteLine("<?xml version='1.0' encoding='UTF-8' standalone='yes'?>")
        sw.WriteLine(wordDok.InnerXml)
        sw.Flush()
        sw.Close()
    End Sub

    Private Sub btnXmlPerAbsatz_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtXmlPerAbsatz.Click
        Dim paraXML As String = String.Empty
        Dim paraBuilder As StringBuilder = New StringBuilder()

        Using pkgWordDok As WordprocessingDocument = WordprocessingDocument.Open(m_FilePath, False)
            Dim wordMainDok As MainDocumentPart = pkgWordDok.MainDocumentPart
            Dim wordDok As Document = wordMainDok.Document
            Dim para As DocumentFormat.OpenXml.Wordprocessing.Paragraph
            Dim paras As IEnumerable(Of DocumentFormat.OpenXml.Wordprocessing.Paragraph) = _
              wordDok.Descendants(Of DocumentFormat.OpenXml.Wordprocessing.Paragraph)()
            For Each para In paras
                paraBuilder.Append(para.OuterXml).Append(vbCrLf)
            Next
            paraXML = paraBuilder.ToString().Replace(m_w_Namespace, "")
            Me.wbDokumentInhalt.Document.Body.InnerText = paraXML
        End Using
    End Sub

    Private Sub txtNurText_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtNurText.Click
        Dim docInhalt As String = String.Empty

        Using pkgWordDok As WordprocessingDocument = WordprocessingDocument.Open(m_FilePath, False)
            Dim wordMainDok As MainDocumentPart = pkgWordDok.MainDocumentPart
            Dim wordDok As Document = wordMainDok.Document
            Dim txts As IEnumerable(Of DocumentFormat.OpenXml.Wordprocessing.Text) = wordDok.Descendants(Of DocumentFormat.OpenXml.Wordprocessing.Text)()
            Dim txt As DocumentFormat.OpenXml.Wordprocessing.Text
            For Each txt In txts
                docInhalt = docInhalt & txt.Text
            Next
        End Using
        Me.wbDokumentInhalt.Document.Body.InnerText = docInhalt
    End Sub

    Private Sub btnTextMitParas_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTextMitParas.Click
        Dim paraBuilder As StringBuilder = New StringBuilder()

        Using pkgWordDok As WordprocessingDocument = WordprocessingDocument.Open(m_FilePath, False)
            Dim wordDok As Document = pkgWordDok.MainDocumentPart.Document
            Dim paras As IEnumerable(Of DocumentFormat.OpenXml.Wordprocessing.Paragraph) = wordDok.Descendants(Of DocumentFormat.OpenXml.Wordprocessing.Paragraph)()
            Dim para As DocumentFormat.OpenXml.Wordprocessing.Paragraph = Nothing
            For Each para In paras
                Dim txt As DocumentFormat.OpenXml.Wordprocessing.Text
                Dim txts As IEnumerable(Of DocumentFormat.OpenXml.Wordprocessing.Text) = para.Descendants(Of DocumentFormat.OpenXml.Wordprocessing.Text)()
                For Each txt In txts
                    paraBuilder.Append(txt.Text)
                Next
                paraBuilder.Append(Environment.NewLine)
            Next
            Me.wbDokumentInhalt.Document.Body.InnerText = paraBuilder.ToString()
        End Using
    End Sub

    Private Sub btnTextMitStruktur_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTextMitStruktur.Click
        Dim docParas As StringBuilder = New StringBuilder(m_HtmlStart)
        Dim paraHtmlTag As String = String.Empty
        Dim paraStyleID As ParagraphStyleId = Nothing
        Dim stylID As String = String.Empty

        Using pkgWordDok As WordprocessingDocument = WordprocessingDocument.Open(m_FilePath, False)
            Dim wordMainDok As MainDocumentPart = pkgWordDok.MainDocumentPart
            Dim wordDok As Document = wordMainDok.Document
            Dim paras As IEnumerable(Of DocumentFormat.OpenXml.Wordprocessing.Paragraph) = wordDok.Body.Descendants(Of DocumentFormat.OpenXml.Wordprocessing.Paragraph)()
            For Each para In paras
                Dim paraProp As DocumentFormat.OpenXml.Wordprocessing.ParagraphProperties = para.ParagraphProperties
                If Not paraProp Is Nothing Then
                    paraStyleID = paraProp.ParagraphStyleId
                End If
                If Not paraStyleID Is Nothing Then
                    stylID = paraStyleID.Val
                End If
                Select Case stylID
                    Case "berschrift1"
                        paraHtmlTag = "h1"
                    Case "berschrift2"
                        paraHtmlTag = "h2"
                    Case "berschrift3"
                        paraHtmlTag = "h3"
                    Case Else
                        paraHtmlTag = "p"
                End Select
                docParas.Append("<" & paraHtmlTag & ">")

                Dim txt As DocumentFormat.OpenXml.Wordprocessing.Text
                Dim txts As IEnumerable(Of DocumentFormat.OpenXml.Wordprocessing.Text) = para.Descendants(Of DocumentFormat.OpenXml.Wordprocessing.Text)()
                For Each txt In txts
                    docParas.Append(txt.Text)
                Next
                docParas.Append("</" & paraHtmlTag & ">" & Environment.NewLine)
                stylID = String.Empty
                paraStyleID = Nothing
                paraProp = Nothing
            Next
            docParas.Append(m_HtmlEnd)
            Me.wbDokumentInhalt.Document.Body.InnerHtml = docParas.ToString()
        End Using
    End Sub

    Private Sub btnFV_Auflisten_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFV_Auflisten.Click
        Dim htmlContent As StringBuilder = New StringBuilder(m_HtmlStart)
        Dim defaultHeadingFont As String = String.Empty
        Dim defaultTextFont As String = String.Empty
        Dim FV_Liste As List(Of String) = Nothing

        Using pkgWordDok As WordprocessingDocument = WordprocessingDocument.Open(m_FilePath, False)
            Dim wordMainDok As MainDocumentPart = pkgWordDok.MainDocumentPart
            'Die standardmässigen Schriftarten sind im Theme-Teil hinterlegt
            defaultHeadingFont = GetThemeFont("major", wordMainDok)
            defaultTextFont = GetThemeFont("minor", wordMainDok)
            htmlContent.Append("<p>Standardschriftart für Überschriften: ").Append(defaultHeadingFont)
            htmlContent.Append("<br/>Standardschriftart für Text: ").Append(defaultTextFont).Append("</p>")

            Dim wordDok As Document = wordMainDok.Document
            FV_Liste = GetFormatVorlagenRefs(wordDok)

            Dim stylePart As StyleDefinitionsPart = wordMainDok.GetPartsOfType(Of StyleDefinitionsPart).FirstOrDefault
            htmlContent.Append(GetFV_Info(stylePart, FV_Liste)).Append(m_HtmlEnd)
            Me.wbDokumentInhalt.Document.Body.InnerHtml = htmlContent.ToString()
        End Using
    End Sub

    Private Function GetThemeFont(ByVal scheme As String, ByVal wordMainDok As MainDocumentPart) As String
        Dim fontName As String = String.Empty
        Dim themePart As ThemePart = wordMainDok.GetPartsOfType(Of ThemePart).FirstOrDefault
        Dim th As DocumentFormat.OpenXml.Drawing.Theme = themePart.Theme
        Select Case scheme
            Case "minor"
                Dim minorLatin As LatinFont = th.Descendants(Of MinorFont).FirstOrDefault.Descendants( _
                    Of LatinFont).FirstOrDefault
                fontName = minorLatin.Typeface.Value
            Case "major"
                Dim majorLatin As LatinFont = th.Descendants(Of MajorFont).FirstOrDefault.Descendants( _
                    Of LatinFont).FirstOrDefault
                fontName = majorLatin.Typeface.Value
            Case Else
        End Select
        Return fontName
    End Function

    Private Function GetFormatVorlagenRefs(ByVal dok As Document) As List(Of String)
        Dim l As List(Of String) = New List(Of String)
        Dim styleId As String

        Dim pStyles As IEnumerable(Of ParagraphStyleId) = dok.Descendants(Of ParagraphStyleId)()
        Dim pStyle As ParagraphStyleId
        For Each pStyle In pStyles
            styleId = pStyle.Val
            If Not l.Contains(styleId) Then
                l.Add(styleId)
            End If
        Next
        Dim rStyles As IEnumerable(Of RunStyle) = dok.Descendants(Of RunStyle)()
        Dim rStyle As RunStyle
        For Each rStyle In rStyles
            styleId = rStyle.Val
            If Not l.Contains(styleId) Then
                l.Add(styleId)
            End If
        Next
        Return l
    End Function

    Private Function GetFV_Info(ByVal stylePart As StyleDefinitionsPart, ByVal FV_Liste As List(Of String)) As String
        Dim FV_Builder As StringBuilder = New StringBuilder
        Dim textEigenschaften As String = String.Empty
        Dim paraEigenschaften As String = String.Empty
        Dim FV As Style = Nothing, FV_Id As String, counter As Integer

        FV_Builder.Append(m_HtmlStartTable).Append(m_HtmlStartTR).Append(m_HtmlStartTD)
        FV_Liste.Insert(0, "Standard")

        'Standard-Formatierungen für das Dokument
        Dim d As DocDefaults = stylePart.Styles.Descendants(Of DocDefaults).FirstOrDefault
        FV_Builder.Append(m_HtmlStartTR & m_HtmlStartTD).Append("Standardformatierung: <br/></td><td>")
        Dim FV_BaseParaProps As ParagraphPropertiesBaseStyle = d.Descendants(Of ParagraphPropertiesBaseStyle).FirstOrDefault
        paraEigenschaften = AbsatzEigenschaftenErmitteln(FV_BaseParaProps)
        FV_Builder.Append(paraEigenschaften)
        Dim FV_BaseRunProps As RunPropertiesBaseStyle = d.Descendants(Of RunPropertiesBaseStyle).FirstOrDefault
        textEigenschaften = TextEigenschaftenErmitteln(FV_BaseRunProps)
        FV_Builder.Append(textEigenschaften).Append("</td>")

        'Die restlichen im Textkörper verwendeten Formatvorlagen
        For Each FV_Id In FV_Liste
            FV = stylePart.Styles.Descendants(Of Style).Where(Function(s) s.StyleId = FV_Id).FirstOrDefault
            FV_Builder.Append(m_HtmlStartTR & m_HtmlStartTD)

            FV_Builder.Append(FV.StyleId.ToString() & "<br/>")
            FV_Builder.Append(FV.StyleName.Val.ToString() & "<br/>")
            FV_Builder.Append("Art: " & FV.Type.Value.ToString()).Append(endTD)

            FV_Builder.Append(m_HtmlStartTD)
            For counter = 0 To FV.ChildElements.Count - 1
                Dim FV_Name As String = FV.ChildElements(counter).LocalName
                Select Case FV_Name
                    Case "name" 'schon bearbeitet
                    Case "pPr"  'durch die Para-Eigenschaften schleifen
                        Dim FV_ParaProps As StyleParagraphProperties = FV.ChildElements(counter)
                        paraEigenschaften = AbsatzEigenschaftenErmitteln(FV_ParaProps)
                        FV_Builder.Append(paraEigenschaften)
                    Case "rPr"  'durch die Run-Eigenschaften schleifen
                        Dim FV_RunProps As StyleRunProperties = FV.ChildElements(counter)
                        textEigenschaften = TextEigenschaftenErmitteln(FV_RunProps)
                        FV_Builder.Append(textEigenschaften)
                    Case Else   'die restlichen Eigenschaften
                        If FV.ChildElements(counter).HasAttributes Then
                            FV_Builder.Append(FV_Name & ": " & FV.ChildElements(counter).GetAttributes(0).Value & "<br/>")
                        End If
                End Select
            Next
            FV_Builder.Append("</td>")
        Next
        FV_Builder.Append("</table>")
        Return FV_Builder.ToString()
    End Function

    'Bearbeitet sowohl StyleParagraphProperties als auch ParagraphPropertiesBaseStyle
    Private Function AbsatzEigenschaftenErmitteln(ByVal oprops As Object) As String
        Dim Para_Builder As StringBuilder = New StringBuilder
        Dim e_s As OpenXmlElementList = oprops.Elements
        If Not e_s Is Nothing Then
            Dim e As OpenXmlElement, prop As String
            For Each e In e_s
                prop = e.GetType().ToString()
                prop = prop.Substring(prop.LastIndexOf(".") + 1)
                Para_Builder.Append(prop).Append("<br/>")
                If e.HasAttributes Then
                    'space before/after
                    Dim a_s As IEnumerable(Of OpenXmlAttribute) = e.GetAttributes
                    Dim a As OpenXmlAttribute, attValue As String = String.Empty
                    For Each a In a_s
                        Select Case a.LocalName
                            Case "after", "before" 'Abstand zwischen Absätze
                                attValue = a.Value / 20
                            Case "line" 'Abstand zwischen Textzeilen
                                attValue = Math.Round(a.Value / 240, 2)
                            Case Else
                                attValue = a.Value
                        End Select
                        Para_Builder.Append("&nbsp;&nbsp;").Append(a.LocalName).Append(": ").Append(attValue).Append("<br/>")
                    Next
                End If
            Next
        End If
        Return Para_Builder.ToString()
        Para_Builder.Clear()
    End Function

    'Bearbeitet sowohl RunParagraphProperties als auch RunPropertiesBaseStyle
    Private Function TextEigenschaftenErmitteln(ByVal oProps As Object) As String
        Dim Run_Builder As StringBuilder = New StringBuilder
        Dim e_s As OpenXmlElementList = oProps.Elements
        If Not e_s Is Nothing Then
            Dim e As OpenXmlElement, prop As String
            For Each e In e_s
                prop = e.GetType().ToString()
                prop = prop.Substring(prop.LastIndexOf(".") + 1)
                Run_Builder.Append(prop).Append("<br/>")
                If e.HasAttributes Then
                    Dim a_s As IEnumerable(Of OpenXmlAttribute) = e.GetAttributes
                    Dim a As OpenXmlAttribute, attVal As String = String.Empty
                    For Each a In a_s
                        Select Case prop
                            Case "Color"
                                If Val(a.Value) > 0 Then
                                    Dim c As System.Drawing.Color = ColorTranslator.FromHtml("#" & a.Value)
                                    If c.IsKnownColor Then
                                        attVal = c.ToKnownColor
                                    Else
                                        attVal = c.ToString()
                                    End If
                                Else
                                    attVal = a.Value
                                End If
                            Case "FontSize", "FontSizeComplexScript"
                                attVal = a.Value / 2
                            Case Else
                                attVal = a.Value
                        End Select
                        Run_Builder.Append("&nbsp;&nbsp;").Append(a.LocalName).Append(": ").Append(attVal).Append("<br/>")
                    Next
                End If
            Next
        End If
        Return Run_Builder.ToString()
        Run_Builder.Clear()
    End Function

    Private Sub OpenXMLSDK_03_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    End Sub

    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        Me.Close()
    End Sub

End Class
