﻿Public Class frmOpenXMLSDK_04

#Region "Geteilte Funktionalität"
    Private m_sWordNamensraum As String = _
        "http://schemas.openxmlformats.org/wordprocessingml/2006/main"
    Private m_sPaketPfad = "C:\Beispiele\Kap25\"
    Private m_sAbsatzZeichen = Chr(13)

    Private Sub ErstelltesDok_Oeffnen(ByVal sPfad As String)
        Dim wdApp As Object

        wdApp = Microsoft.VisualBasic.CreateObject("Word.Application")
        wdApp.Visible = True
        wdApp.Documents.Open(sPfad)
        wdApp.ActiveWindow.Activate()
        wdApp = Nothing
    End Sub

    Private Enum Inhalt_Mode
        XML = 1
        LinqSchrittweise = 2
        LinqEinSchritt = 3
    End Enum


    Private Function WordDok_Erstellen(ByVal sDatei As String, ByVal sInhalt As String, ByVal mode As Inhalt_Mode) As Boolean

        Dim erfolg As Boolean = True
        Using pkgDoc = WordprocessingDocument.Create( _
              m_sPaketPfad & sDatei, WordprocessingDocumentType.Document)
            Dim partMainDok As MainDocumentPart = pkgDoc.AddMainDocumentPart()
            Dim docMainDok As Document = New Document()
            Select Case mode
                Case Inhalt_Mode.XML
                    DokInhalt_Erstellen_XML(doc:=docMainDok, sXml:=sInhalt)
                Case Inhalt_Mode.LinqSchrittweise
                    DokInhalt_Erstellen_LINQ1(doc:=docMainDok, sTextInhalt:=sInhalt)
                Case Inhalt_Mode.LinqEinSchritt
                    DokInhalt_Erstellen_LINQ2(doc:=docMainDok, sTextInhalt:=sInhalt, mode:=Inhalt_Mode.LinqEinSchritt)
                Case Else
                    MessageBox.Show("Unbekannter Modus. Abbruch.")
                    Return False
            End Select
            docMainDok.Save(partMainDok)
            Return erfolg
        End Using
    End Function

    Private Sub LeerenLetztenAbsatzEntfernen(ByRef Doc As Document)
        'Leeren letzten Absatz entfernen
        Dim paraLast As Paragraph = Doc.Body.Elements(Of Paragraph).LastOrDefault()
        Dim paraLastText As Text = paraLast.Descendants(Of Text).FirstOrDefault()
        If IsNothing(paraLastText) And Not IsNothing(paraLast) Then
            paraLast.Remove()
        ElseIf paraLastText.InnerText.Length = 0 Or paraLastText.Text.Length = 1 Then
            paraLast.Remove()
        End If
    End Sub

#End Region 'Geteilte Funktionalität

#Region "Abschnitt Dokumente erstellen"
    Private Sub btnDokumenttext_XML_Click( _
                                              ByVal sender As System.Object, _
                                              ByVal e As System.EventArgs) _
                                          Handles btnDokumenttext_XML.Click
        Dim sDateiName = "Dok_XML.docx"
        Dim sDokXML As String = _
            "<w:body><w:p><w:r><w:t>Dieser Inhalt wurde als XML-Zeichenkette " & _
            "in das Dokument geschrieben.</w:t></w:r></w:p></w:body>"
        WordDok_Erstellen(sDatei:=sDateiName, sInhalt:=sDokXML, mode:=Inhalt_Mode.XML)
        ErstelltesDok_Oeffnen(m_sPaketPfad & sDateiName)
    End Sub

    Private Sub btnDokumenttext_LINQ1_Click(ByVal sender As System.Object, _
                                             ByVal e As System.EventArgs) _
                                         Handles btnDokumenttext_LINQ1.Click
        Dim sDateiName As String = "Dok_LINQ1.docx"
        Dim sTextInhalt As String = _
            "Dieser Inhalt wurde mit LINQ in das Dokument geschrieben."
        WordDok_Erstellen(sDatei:=sDateiName, sInhalt:=sTextInhalt, mode:=Inhalt_Mode.LinqSchrittweise)
        ErstelltesDok_Oeffnen(m_sPaketPfad & sDateiName)
    End Sub

    Private Sub btnDokumenttext_LINQ2_Click( _
                                               ByVal sender As System.Object, _
                                               ByVal e As System.EventArgs) _
                                           Handles btnDokumenttext_LINQ2.Click
        Dim sDateiName = "Dok_LINQ2.docx"
        Dim sTextInhalt As String = _
            "Dieser Inhalt wurde mit LINQ in das Dokument geschrieben."
        If WordDok_Erstellen(sDatei:=sDateiName, sInhalt:=sTextInhalt, _
                             mode:=Inhalt_Mode.LinqEinSchritt) Then
            ErstelltesDok_Oeffnen(m_sPaketPfad & sDateiName)
        End If
    End Sub
    Private Sub DokInhalt_Erstellen_XML(ByRef doc As Document, _
                                       ByVal sXml As String)
        doc.InnerXml = sXml
    End Sub

    Private Sub DokInhalt_Erstellen_LINQ1(ByVal doc As Document, _
                                          ByVal sTextInhalt As String)
        Dim elemText As Wordprocessing.Text = New Wordprocessing.Text()
        elemText.Text = sTextInhalt
        Dim elemRun As Run = New Run()
        elemRun.Append(elemText)
        Dim elemPara As New Paragraph()
        elemPara.Append(elemRun)
        Dim elemBody As Body = New Body()
        elemBody.Append(elemPara)
        doc.Append(elemBody)
    End Sub

    Private Sub DokInhalt_Erstellen_LINQ2(ByVal doc As Document, _
                                          ByVal sTextInhalt As String,
                                          ByVal mode As Inhalt_Mode)
        Dim bod As Body = New Body( _
                         New Paragraph( _
                             New Run( _
                                 New Wordprocessing.Text(sTextInhalt))))
        doc.Append(bod)
    End Sub

#End Region 'Dokumente erstellen

#Region "Abschnitt Inhalt aus Textdateien"
    Private Sub btnInhaltAusTextDateien_Click(ByVal sender As System.Object, _
                                             ByVal e As System.EventArgs) Handles _
                                         btnInhaltAusTextDateien.Click

        Dim sDokNameXML = "WordOpenXMLZufuegen.docx" 'Zu erstellender Datei
        Dim sDateiNameXML = "WordOpenXML.txt"        'Quelle mit Dokumentinhalt
        Dim sDateiNameText = "TextInhalt.txt"        'Quelle mit weiterem Dokumentinhalt
        Dim sWordOpenXmlInhalt As String = GetTextAusDatei(m_sPaketPfad + sDateiNameXML)

        If sWordOpenXmlInhalt <> String.Empty Then
            'Falls das Element <w:document> und evtl. weitere voranstehenden Elemente
            'im XML vorhanden sind, diese entfernen.
            VoranstehendenElementeEntfernen(sXML:=sWordOpenXmlInhalt)
            'Sicherstellen, dass ein <w:body> Element vorhanden ist.
            'Sonst gehen wir davon aus, dass der Text gültiges Word Open XML ist.
            If sWordOpenXmlInhalt.Contains("<w:body") Then
                Using pkgDoc = WordprocessingDocument.Create( _
          m_sPaketPfad & sDokNameXML, WordprocessingDocumentType.Document)

                    Dim partMainDok As MainDocumentPart = WordDokPart_Erstellen(pkg:=pkgDoc, _
                                                                                sInhalt:=sWordOpenXmlInhalt, _
                                                                                mode:=Inhalt_Mode.XML)
                    If Not IsNothing(partMainDok) Then
                        Dim sTextInhalt As String = GetTextAusDatei(m_sPaketPfad + sDateiNameText)
                        TextInhaltZufuegen(sTextInhalt, partMainDok)
                    End If
                End Using
                ErstelltesDok_Oeffnen(m_sPaketPfad & sDokNameXML)
            End If
        End If
    End Sub

    'Wichtig: Textdateien sollen als Unicode, nicht ASCII oder ANSI gespeichert werden.
    'Sonst werden Umlaut-Zeichen u.ä. nicht beibehalten.
    Private Function GetTextAusDatei(ByVal sDateipfad As String) As String
        Dim sTextAusDatei As String = String.Empty
        Dim fi As System.IO.FileInfo = New System.IO.FileInfo(sDateipfad)
        If fi.Exists Then
            Using reader As System.IO.StreamReader = New System.IO.StreamReader( _
                                                     sDateipfad, System.Text.Encoding.UTF8, True)
                sTextAusDatei = reader.ReadToEnd
            End Using
        End If
        Return sTextAusDatei
    End Function

    Private Function WordDokPart_Erstellen(ByVal pkg As WordprocessingDocument, _
                                           ByVal sInhalt As String, ByVal mode As Inhalt_Mode) _
                                       As MainDocumentPart
        Dim partMainDok As MainDocumentPart = pkg.AddMainDocumentPart()
        Dim docMainDok As Document = New Document()
        Select Case mode
            Case Inhalt_Mode.XML
                DokInhalt_Erstellen_XML(doc:=docMainDok, sXml:=sInhalt)
            Case Inhalt_Mode.LinqSchrittweise
                DokInhalt_Erstellen_LINQ1(doc:=docMainDok, sTextInhalt:=sInhalt)
            Case Inhalt_Mode.LinqEinSchritt
                DokInhalt_Erstellen_LINQ2(doc:=docMainDok, sTextInhalt:=sInhalt, mode:=Inhalt_Mode.LinqEinSchritt)
            Case Else
                MessageBox.Show("Unbekannter Modus. Abbruch.")
                Return Nothing
        End Select
        docMainDok.Save(partMainDok)
        Return partMainDok
    End Function

    Private Sub TextInhaltZufuegen(ByVal sTextInhalt As String, _
                                   ByVal partMainDok As MainDocumentPart)
        Dim Dok As Document = partMainDok.Document
        Dim bod As Body = Dok.Body

        Dim paraNeu As Paragraph = Nothing
        Dim separator() As String = {m_sAbsatzZeichen}
        Dim paras As Array = sTextInhalt.Split(separator, _
                                               System.StringSplitOptions.RemoveEmptyEntries)
        Dim paraCounter As Integer
        For paraCounter = 0 To UBound(paras)
            paraNeu = New Paragraph(New Run(New Text(paras(paraCounter))))
            bod.Append(paraNeu)
        Next

        ''Wenn die folgenden statt die obigen Codezeilen ausgeführt werden,
        ''gehen die Zeilenschaltungen verloren.
        'Dim para As New Paragraph(New Run(New Text(sTextInhalt)))
        'bod.Append(para)
        Dok.Save()
    End Sub

    'Enfernt das Element <w:document> sowie weitere voranstehenden
    'Elementen am Anfang des Word Open XML.
    Private Sub VoranstehendenElementeEntfernen(ByRef sXML As String)
        Dim sDocumentElement As String = "<w:document"
        If sXML.Contains(sDocumentElement) Then
            Dim iStart As Integer = sXML.IndexOf(sDocumentElement)
            sXML = sXML.Substring(iStart)    'Alles bis zum Element w:document entfernen
            Dim iEnd As Integer = sXML.IndexOf(">")
            sXML = sXML.Substring(iEnd + 1)  'Das Element w:document entfernen
            Dim sEndElement As String = "</w:document"
            iStart = sXML.IndexOf(sEndElement)
            sXML = sXML.Substring(0, iStart) 'Das Element /w:document entfernen
        End If
    End Sub
#End Region 'Inhalt aus Textdateien

#Region "Abschnitt Bausteine"
    Private Sub btn_BausteineAlsDokInhalt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_BausteineAlsDokInhalt.Click
        Dim sDokument_Dateiname As String = "Beispiel25_02_Resultat.docx" 'Ergebnis des Abschnitts Inhalt aus Textdateien
        Dim sBausteine_Dateiname As String = "Beispiel25_01.dotx"

        Using pkgDok As WordprocessingDocument = WordprocessingDocument.Open( _
            m_sPaketPfad & sDokument_Dateiname, True)

            Dim Dok As Document = pkgDok.MainDocumentPart.Document
            LeerenLetztenAbsatzEntfernen(Doc:=Dok)

            Using pkgBausteine As WordprocessingDocument = WordprocessingDocument.Open( _
                m_sPaketPfad & sBausteine_Dateiname, False)

                Dim partGlossary As GlossaryDocumentPart = pkgBausteine.MainDocumentPart.GlossaryDocumentPart
                If Not IsNothing(partGlossary) Then
                    Dim dokGlossar As GlossaryDocument = partGlossary.GlossaryDocument
                    Dim glossEntry As DocPart = dokGlossar.DocParts().Descendants(Of DocPart).Where( _
                        Function(dp) dp.DocPartProperties.DocPartName.Val = "DokumentInhalt").FirstOrDefault()

                    If Not IsNothing(glossEntry) Then
                        Dim glossInhalt As String = glossEntry.Descendants(Of DocPartBody).FirstOrDefault.InnerXml.ToString
                        Dok.Body.InnerXml = Dok.Body.InnerXml.Insert(Dok.Body.InnerXml.Length, glossInhalt)
                    End If
                End If
            End Using
            Dok.Save()
        End Using
        ErstelltesDok_Oeffnen(m_sPaketPfad & sDokument_Dateiname)
    End Sub

#End Region 'Bausteine

#Region "Abschnitt Externes Dokument"
    Private Sub btnExternesDokument_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                          Handles btnExternesDokument.Click
        Dim sExDok_Dateiname = "ExtenernerInhalt.docx"
        Dim sDokument_Dateiname = "Beispiel25_03_Resultat.docx"
        Dim altChunkId As String = "ac1"

        Using pkgDok As WordprocessingDocument = WordprocessingDocument.Open( _
            m_sPaketPfad & sDokument_Dateiname, True)

            Dim Dok As Document = pkgDok.MainDocumentPart.Document
            LeerenLetztenAbsatzEntfernen(Dok)
            Dim partChunk As AlternativeFormatImportPart = pkgDok.MainDocumentPart.AddAlternativeFormatImportPart( _
                AlternativeFormatImportPartType.WordprocessingML, altChunkId)
            Using fs As System.IO.FileStream = System.IO.File.Open( _
                m_sPaketPfad & sExDok_Dateiname, System.IO.FileMode.Open)

                partChunk.FeedData(fs)
            End Using

            Dim ac As AltChunk = New AltChunk()
            ac.Id = altChunkId
            Dok.Body.InsertAfter(ac, Dok.Body.Elements(Of Paragraph).Last)
            Dok.Save()
        End Using
        ErstelltesDok_Oeffnen(m_sPaketPfad & sDokument_Dateiname)
    End Sub

#End Region 'Externes Dokument

#Region "Kompatibilitätsmodus"
    Private Sub btnKompatibilitätsmodus_Click(ByVal sender As System.Object, _
                                              ByVal e As System.EventArgs) Handles btnKompatibilitätsmodus.Click

        Dim sDokument_DateiName As String = "Beispiel25_04_Resultat.docx"
        Dim s_Version As String = "15"

        Using pkgDok As WordprocessingDocument = WordprocessingDocument.Open( _
                                                 m_sPaketPfad & sDokument_DateiName, True)
            Dim partHauptDok As MainDocumentPart = pkgDok.MainDocumentPart
            Dim partSettings As DocumentSettingsPart = partHauptDok.GetPartsOfType( _
                                                       Of DocumentSettingsPart).FirstOrDefault
            If partSettings Is Nothing Then 'Der Teil mit Inhalt muss erstellt werden.
                partSettings = partHauptDok.AddNewPart(Of DocumentSettingsPart)()
                partSettings.Settings = CompatibilityModeSettingErstellen_XML(s_Version:=s_Version)
            Else 'Der Teil ist vorhanden und wir nehmen an, er hat Inhalt...
                Dim settings As Settings = partSettings.Settings
                Dim compat As Compatibility = settings.Elements(Of Compatibility).FirstOrDefault
                If compat Is Nothing Then 'Falls kein Element w:compat vorhanden ist, es mit Inhalt erstellen.
                    CompatibilityModeSettingErstellen_Linq(compat:=compat, s_Version:=s_Version)
                    settings.Append(compat)
                Else 'Sonst herausfinden, ob...
                    Dim compatSetting As CompatibilitySetting = Nothing
                    compatSetting = compat.Elements(Of CompatibilitySetting).Where( _
                                     Function(cs) cs.Name = "compatibilityMode").FirstOrDefault()
                    If compatSetting Is Nothing Then 'kein <w:compatSetting> vorhanden ist und eins erstellen.
                        compatSettingFestlegen(compatSetting:=compatSetting, s_Version:=s_Version)
                    Else 'Falls ja, nur die Version festlegen.
                        compatSetting.Val = s_Version
                    End If
                End If
            End If
        End Using
        ErstelltesDok_Oeffnen(m_sPaketPfad & sDokument_DateiName)
    End Sub

    Private Function CompatibilityModeSettingErstellen_XML(ByVal s_Version As String) As Settings
        Dim settings As Settings
        Dim s_Uri As String = "http://schemas.microsoft.com/office/word"
        Dim s_compatSetting = "<w:settings xmlns:w='" & m_sWordNamensraum & _
            "'><w:compat xmlns:w='" & m_sWordNamensraum & "'><w:compatSetting xmlns:w='" _
            & m_sWordNamensraum & "' w:val='" & s_Version & "' w:uri='" & s_Uri & _
            "' w:name='compatibilityMode'/></w:compat></w:settings>"
        settings = New Settings(s_compatSetting)
        Return settings
    End Function

    Private Sub CompatibilityModeSettingErstellen_Linq(ByRef compat As Compatibility, ByVal s_Version As String)
        Dim compatSetting As CompatibilitySetting

        compatSetting = New CompatibilitySetting
        compatSettingFestlegen(compatSetting:=compatSetting, s_Version:=s_Version)
        compat.Append(compatSetting)
    End Sub

    Private Sub compatSettingFestlegen(ByRef compatSetting As CompatibilitySetting, ByVal s_Version As String)
        compatSetting.Name = New EnumValue(Of CompatSettingNameValues)( _
                               CompatSettingNameValues.CompatibilityMode)
        compatSetting.Val = s_Version
        compatSetting.Uri = "http://schemas.microsoft.com/office/word"
    End Sub
#End Region 'Kompatibilitätsmodus

#Region "Weitere Eintstellungen"
    Private Sub btnWeitereEinstellungen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                              Handles btnWeitereEinstellungen.Click
        Dim sDokument_DateiName As String = "Beispiel25_05_Resultat.docx"
        Dim sv_Trennzeichen As StringValue = "."
        Dim sv_Listingtrennzeichen As StringValue = ","
        Dim iv_DefaultTabstopp As Int16Value = 567
        Dim sv_Zoom As StringValue = "100%"

        Using pkgDok As WordprocessingDocument = WordprocessingDocument.Open( _
                                                 m_sPaketPfad & sDokument_DateiName, True)
            Dim partHauptDok As MainDocumentPart = pkgDok.MainDocumentPart
            Dim partSettings As DocumentSettingsPart = partHauptDok.GetPartsOfType( _
                                                       Of DocumentSettingsPart).FirstOrDefault
            If partSettings Is Nothing Then 'Der Teil mit Inhalt muss erstellt werden.
                partSettings = partHauptDok.AddNewPart(Of DocumentSettingsPart)()
            End If
            Dim settings As Settings = partSettings.Settings
            TrennzeichenFestlegen(settings:=settings, Trennzeichen:=sv_Trennzeichen, _
                                  Listingtrennzeichen:=sv_Listingtrennzeichen)
            TabstoppFestlegen(settings:=settings, Tabstopp:=iv_DefaultTabstopp)
            ZoomFestlegen(settings:=settings, ZoomFaktor:=sv_Zoom)
        End Using
    End Sub

    Private Sub TrennzeichenFestlegen(ByVal settings As Settings, ByVal Trennzeichen As StringValue, _
                                      ByVal Listingtrennzeichen As StringValue)
        Dim tz As DocumentFormat.OpenXml.Wordprocessing.DecimalSymbol = settings.Elements(Of DecimalSymbol)().FirstOrDefault
        If tz Is Nothing Then
            CreateNewElementWithVal(settings:=settings, t:="DocumentFormat.OpenXml.Wordprocessing.DecimalSymbol", _
                                    propName:="Val", propval:=Trennzeichen)
        Else
            tz.Val = Trennzeichen
        End If
        Dim ltz As ListSeparator = settings.Elements(Of ListSeparator)().FirstOrDefault
        If ltz Is Nothing Then
            CreateNewElementWithVal(settings:=settings, t:="DocumentFormat.OpenXml.Wordprocessing.ListSeparator", _
                                    propName:="Val", propval:=Listingtrennzeichen)
        Else
            ltz.Val = Listingtrennzeichen
        End If
    End Sub

    Private Sub TabstoppFestlegen(ByVal settings As Settings, ByVal Tabstopp As Int16Value)
        Dim ts As DefaultTabStop = settings.Elements(Of DefaultTabStop)().FirstOrDefault
        If ts Is Nothing Then
            CreateNewElementWithVal(settings:=settings, t:="DocumentFormat.OpenXml.Wordprocessing.DefaultTabStop", _
                                    propName:="Val", propval:=Tabstopp)
        Else
            ts.Val = Tabstopp
        End If
    End Sub

    Private Sub ZoomFestlegen(ByVal settings As Settings, ByVal ZoomFaktor As StringValue)
        Dim zf As Zoom = settings.Elements(Of Zoom)().FirstOrDefault
        If zf Is Nothing Then
            CreateNewElementWithVal(settings:=settings, t:="DocumentFormat.OpenXml.Wordprocessing.Zoom", _
                                    propName:="Percent", propval:=ZoomFaktor)
            'zf = New Zoom With {.Percent = ZoomFaktor}
            'settings.Append(zf)
        Else
            zf.Percent = ZoomFaktor
        End If
    End Sub

    Private Function CreateNewElementWithVal(ByVal settings As Settings, ByVal t As String, _
                                               ByVal propName As String, ByVal propval As Object) _
                                               As Object
        Dim a As System.Reflection.Assembly = System.Reflection.Assembly.GetAssembly(settings.GetType)
        Dim classType As Type = a.GetType(t)
        Dim o As Object = Activator.CreateInstance(classType)
        Dim prop As System.Reflection.PropertyInfo = classType.GetProperty(propName)
        prop.SetValue(o, propval, Nothing)
        settings.Append(o)
        Return o
    End Function

#End Region 'Weitere Einstellungen

    Private Sub btnFertig_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFertig.Click
        Me.Close()
    End Sub


End Class
