﻿Public Class frmOpenXMLSDK_05
    Dim m_sDateiPfad As String = "C:\Test\"

#Region "DocDefaults"
    Private Sub btnDocDefaults_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                     Handles btnDocDefaults.Click
        Dim sDateiName As String = "Beispiel26_01_1.docx" '"Beispiel26_01_2.docx"

        Using pkgDoc As WordprocessingDocument = WordprocessingDocument.Open(m_sDateiPfad & sDateiName, True)
            Dim partDok As MainDocumentPart = pkgDoc.MainDocumentPart
            Dim partFV As StyleDefinitionsPart = partDok.GetPartsOfType(Of StyleDefinitionsPart).FirstOrDefault
            If partFV Is Nothing Then
                partFV = DokumentFormat_Festlegen(partDok:=partDok)
            End If
        End Using
        ErstelltesDok_Oeffnen(m_sDateiPfad & sDateiName)
    End Sub

    Private Function DokumentFormat_Festlegen(ByVal partDok As MainDocumentPart)
        Dim partFV As StyleDefinitionsPart = partDok.AddNewPart(Of StyleDefinitionsPart)()
        Dim FV As Styles = New Styles
        Dim paraAusrichtungVoll As EnumValue(Of JustificationValues) = JustificationValues.Both

        DocDefaults_Zufuegen(FV:=FV, Schriftart:="Arial Standard", Schriftgroesse:=16, Sprache:="de-CH", _
                             ParaAbstandNach:=60, ParaAusrichtung:=paraAusrichtungVoll)
        partFV.Styles = FV
        Return partFV
    End Function
#End Region 'DocDefaults

#Region "Formatvorlagen-Teil"
    Private Sub btnFormatvorlagen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFormatvorlagen.Click
        Dim sDateiName As String = "Beispiel26_01_1_Resultat.docx" '"Beispiel26_01_2_Resultat.docx"

        Using pkgDoc As WordprocessingDocument = WordprocessingDocument.Open(m_sDateiPfad & sDateiName, True)
            Dim partDok As MainDocumentPart = pkgDoc.MainDocumentPart
            Dim partFV As StyleDefinitionsPart = partDok.GetPartsOfType(Of StyleDefinitionsPart).FirstOrDefault
            If partFV Is Nothing Then
                partFV = Formatvorlagenteil_Erstellen(partDok:=partDok)
            End If
        End Using
        ErstelltesDok_Oeffnen(m_sDateiPfad & sDateiName)
    End Sub

    Private Function Formatvorlagenteil_Erstellen(ByVal partDok As MainDocumentPart)
        Dim partFV As StyleDefinitionsPart = partDok.AddNewPart(Of StyleDefinitionsPart)()
        Dim FV As Styles = New Styles
        Dim paraAusrichtungLinks As EnumValue(Of JustificationValues) = JustificationValues.Start
        Dim paraAusrichtungZentriert As EnumValue(Of JustificationValues) = JustificationValues.Center
        Dim stylTypePara As EnumValue(Of StyleValues) = StyleValues.Paragraph
        Dim stylTypeChar As EnumValue(Of StyleValues) = StyleValues.Character
        Dim h1Gliederungsebene As Integer = 0
        Dim h2Gliederungsebene As Integer = 1

        FV_DefParaFont_Zufuegen(FV:=FV, StyleType:=stylTypeChar)
        FV_Normal_Zufuegen(FV:=FV, Schriftart:="Times New Roman", Schriftgroesse:=24, Sprache:="de-DE", _
                             ParaAusrichtung:=paraAusrichtungLinks, StyleType:=stylTypePara)
        FV_H1_Zufuegen(FV:=FV, Schriftart:="Calibri", Schriftgroesse:=32, GliederungsEbene:=h1Gliederungsebene, _
                             ParaAbstandVor:=120, ParaAusrichtung:=paraAusrichtungLinks, StyleType:=stylTypePara)
        FV_H2_Zufuegen(FV:=FV, Schriftgroesse:=24, GliederungsEbene:=h2Gliederungsebene, _
                             ParaAbstandVor:=60, StyleType:=stylTypePara)
        FV_MeinTitel_Zufuegen(FV:=FV, Schriftart:="Cambria", Schriftgroesse:=40, _
                              ParaAusrichtung:=paraAusrichtungZentriert, ParaAbstandNach:=200, StyleType:=stylTypePara)
        partFV.Styles = FV
        Return partFV
    End Function
#End Region 'Formatvorlagen-Teil

#Region "Formatvorlagen-Definitionen"
    Private Sub DocDefaults_Zufuegen(ByRef FV As Styles, ByVal Schriftart As String, _
                                     ByVal Schriftgroesse As Integer, ByVal Sprache As String, _
                                     ByVal ParaAusrichtung As EnumValue(Of JustificationValues), ByVal ParaAbstandNach As Integer)

        Dim DokDefaults As DocDefaults = New DocDefaults(New ParagraphPropertiesDefault(New ParagraphPropertiesBaseStyle( _
                                                         New SpacingBetweenLines With {.After = ParaAbstandNach}, _
                                                         New Justification With {.Val = ParaAusrichtung})), _
                                                 New RunPropertiesDefault(New RunPropertiesBaseStyle( _
                                                         New RunFonts With {.Ascii = Schriftart}, _
                                                                             New FontSize With {.Val = Schriftgroesse}, _
                                                                             New Languages With {.Val = Sprache})))

        FV.Append(DokDefaults)
    End Sub

    Private Sub FV_DefParaFont_Zufuegen(ByVal FV As Styles, ByVal StyleType As EnumValue(Of StyleValues))

        Dim stylDefParaFont As Style = New Style(New Name With {.Val = "Default Paragraph Font"}) _
                                    With {.StyleId = "Absatz-Standardschriftart", .Type = StyleType, _
                                          .Default = New OnOffValue With {.Value = True}}
        FV.Append(stylDefParaFont)
    End Sub

    Private Sub FV_Normal_Zufuegen(ByVal FV As Styles, ByVal Schriftart As String, ByVal Schriftgroesse As Integer, ByVal Sprache As String, _
                                   ByVal ParaAusrichtung As EnumValue(Of JustificationValues), _
                                    ByVal StyleType As EnumValue(Of StyleValues))

        Dim stylNormal As Style = New Style(New Name With {.Val = "normal"}, _
                New StyleParagraphProperties(New Justification With {.Val = ParaAusrichtung}), _
                New StyleRunProperties(New RunFonts With {.Ascii = Schriftart}, _
                                        New FontSize With {.Val = Schriftgroesse}, _
                                    New Languages With {.Val = Sprache})) _
                                With {.StyleId = "Standard", .Type = StyleType, .Default = 1}
        FV.Append(stylNormal)
    End Sub

    Private Sub FV_H1_Zufuegen(ByVal FV As Styles, ByVal Schriftart As String, ByVal Schriftgroesse As Integer, _
                               ByVal GliederungsEbene As Integer, ByVal ParaAbstandVor As Integer, _
                               ByVal ParaAusrichtung As EnumValue(Of JustificationValues), _
                               ByVal StyleType As EnumValue(Of StyleValues))

        Dim stylH1 As Style = New Style(New Name With {.Val = "heading 1"}, New BasedOn With {.Val = "Standard"}, _
                New StyleParagraphProperties(New SpacingBetweenLines With {.Before = ParaAbstandVor},
                                                New OutlineLevel With {.Val = GliederungsEbene}, _
                                                New Justification With {.Val = ParaAusrichtung}), _
                New StyleRunProperties(New RunFonts With {.Ascii = Schriftart}, _
                                                             New FontSize With {.Val = Schriftgroesse}, _
                                                             New Bold With {.Val = True})) _
                                         With {.StyleId = "berschrift1", .Type = StyleType}
        FV.Append(stylH1)
    End Sub

    Private Sub FV_H2_Zufuegen(ByVal FV As Styles, ByVal Schriftgroesse As Integer, ByVal GliederungsEbene As Integer, _
                               ByVal ParaAbstandVor As Integer, ByVal StyleType As EnumValue(Of StyleValues))

        Dim stylH2 As Style = New Style(New Name With {.Val = "heading 2"}, New BasedOn With {.Val = "berschrift1"}, _
                New StyleParagraphProperties(New SpacingBetweenLines With {.Before = ParaAbstandVor}, _
                                             New OutlineLevel With {.Val = GliederungsEbene}), _
                New StyleRunProperties(New FontSize With {.Val = Schriftgroesse})) _
                                         With {.StyleId = "berschrift2", .Type = StyleType}
        FV.Append(stylH2)
    End Sub

    Private Sub FV_MeinTitel_Zufuegen(ByVal FV As Styles, ByVal Schriftart As String, ByVal Schriftgroesse As Integer, _
                               ByVal ParaAusrichtung As EnumValue(Of JustificationValues), _
                               ByVal ParaAbstandNach As Integer, ByVal StyleType As EnumValue(Of StyleValues))

        Dim stylMeinTitel As Style = New Style(New Name With {.Val = "MeinTitel"}, New BasedOn With {.Val = "Standard"}, _
                New StyleParagraphProperties(New SpacingBetweenLines With {.After = ParaAbstandNach}, _
                                             New Justification With {.Val = ParaAusrichtung}), _
                New StyleRunProperties(New RunFonts With {.Ascii = Schriftart}, New Bold With {.Val = True}, _
                                       New FontSize With {.Val = Schriftgroesse})) _
                                                With {.StyleId = "MeinTitel", .Type = StyleType, .CustomStyle = True}
        FV.Append(stylMeinTitel)
    End Sub
#End Region 'Formatvorlagen-Definitionen

#Region "Text mit FV formatieren"
    Private Sub FV_TextMitTagsZuweisen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
        Handles FV_TextZuweisen.Click, btnFV_TextMitTagsZuweisen.Click

        Dim sDateiName As String = "Beispiel26_03_1.docx"
        Dim svFV_H1 As StringValue = New StringValue("berschrift1")
        Dim sTag As String = "<h1>", sTagStart As String = "&lt;h1&gt;", sTagEnde As String = "&lt;/h1&gt;"

        Using pkgDoc As WordprocessingDocument = WordprocessingDocument.Open(m_sDateiPfad & sDateiName, True)
            Dim Dok As Document = pkgDoc.MainDocumentPart.Document

            Dim parasH1 As IEnumerable(Of Paragraph) = Dok.Body.Descendants(Of Paragraph).Where( _
                Function(p) p.InnerText.Contains(sTag))
            Dim para As Paragraph = Nothing
            For Each para In parasH1
                'FV des Absatzes ermitteln, sofern vorhanden.
                Dim paraStyle As ParagraphStyleId = para.Descendants(Of ParagraphStyleId)().FirstOrDefault
                'Alle Absätze, die noch keine FV-Weisung haben, werden als H1 formatiert.
                If paraStyle Is Nothing Then
                    Dim paraProps As ParagraphProperties = para.ParagraphProperties
                    If paraProps Is Nothing Then
                        'Sind keine Absatzeigenschaften vorhanden, das Element mit FV-Element zufügen.
                        paraProps = New ParagraphProperties(New ParagraphStyleId With {.Val = svFV_H1})
                        para.InsertAt(paraProps, 0)
                    Else
                        'Falls Absatzeigenschaften schon vorhanden sind, das FV-Element zufügen.
                        paraStyle = New ParagraphStyleId With {.Val = svFV_H1}
                        paraProps.Append(paraStyle)
                    End If
                End If
            Next
            Dok.InnerXml = Dok.InnerXml.ToString().Replace(sTagStart, String.Empty)
            Dok.InnerXml = Dok.InnerXml.Replace(sTagEnde, String.Empty)
        End Using
        ErstelltesDok_Oeffnen(m_sDateiPfad & sDateiName)
    End Sub

    Private Sub FV_TextZuweisen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
        Handles FV_TextZuweisen.Click
        Dim sDateiName As String = "Beispiel26_02_Resultat_1.docx"
        Dim svFV_H1 As StringValue = New StringValue("berschrift1")
        Dim ZweiHinFolge As Boolean = False 'Wahr, wenn zwei Absätze in Folge mit Überschrift formatiert sind.
        Dim MaxAnzahlZeichenImAbsatz As Integer = 20

        Using pkgDoc As WordprocessingDocument = WordprocessingDocument.Open(m_sDateiPfad & sDateiName, True)
            Dim Dok As Document = pkgDoc.MainDocumentPart.Document
            'Absätze mit 20 oder weniger Zeichen ermitteln.
            Dim parasH1 As IEnumerable(Of Paragraph) = Dok.Body.Descendants(Of Paragraph).Where( _
                Function(p) p.InnerText.Length > 1 And p.InnerText.Length <= MaxAnzahlZeichenImAbsatz)
            Dim para As Paragraph = Nothing
            For Each para In parasH1
                'Zwei aufeinander folgenden Absätze sollen nicht als Überschriften formatiert werden.
                ZweiHinFolge = FolgtAbsatz_AbsatzMitFV(Absatz:=para, FVName:="berschrift")
                'FV des Absatzes ermitteln, sofern vorhanden.
                Dim paraStyle As ParagraphStyleId = para.Descendants(Of ParagraphStyleId)().FirstOrDefault
                'Alle Absätze mit 20 oder weniger Zeichen, die noch keine FV-Weisung haben, 
                'und nicht dirket auf einen Überschrift-Absatz folgen, werden als H1 formatiert.
                If paraStyle Is Nothing And Not ZweiHinFolge Then
                    Dim paraProps As ParagraphProperties = para.ParagraphProperties
                    If paraProps Is Nothing Then
                        'Sind keine Absatzeigenschaften vorhanden, das Element mit FV-Element zufügen.
                        paraProps = New ParagraphProperties(New ParagraphStyleId With {.Val = svFV_H1})
                        para.InsertAt(paraProps, 0)
                    Else
                        'Falls Absatzeigenschaften schon vorhanden sind, das FV-Element zufügen.
                        paraStyle = New ParagraphStyleId With {.Val = svFV_H1}
                        paraProps.Append(paraStyle)
                    End If
                End If
            Next
        End Using
        ErstelltesDok_Oeffnen(m_sDateiPfad & sDateiName)
    End Sub

    'Ermittelt, ob der angegebene Absatz einem Absatz mit der angegebenen Formatvorlage folgt.
    'Zweck: zwei aufeinander folgengenden Absätze sollen nicht als Überschriften formatiert werden.
    Private Function FolgtAbsatz_AbsatzMitFV(ByVal Absatz As Paragraph, ByVal FVName As String) _
                                             As Boolean
        Dim FolgtUeberschriftAbsatz As Boolean = False
        If Not Absatz.PreviousSibling Is Nothing Then
            'Sofern ein Element auf gleicher Hierarchieebene vorhanden und des gleichen Datentyps ist,
            If Absatz.PreviousSibling.GetType() = Absatz.GetType() Then
                'ermitteln, ob jener Absatz auf eine FV weist.
                If Not Absatz.PreviousSibling.Descendants(Of ParagraphStyleId).FirstOrDefault _
                                                          Is Nothing Then
                    'Falls ja, ermitteln, ob es sich um eine Überschrift-FV handelt.
                    If Absatz.PreviousSibling.Descendants(Of ParagraphStyleId).FirstOrDefault. _
                                                          Val.ToString.Contains(FVName) Then
                        FolgtUeberschriftAbsatz = True
                    End If
                End If
            End If
        End If
        Return FolgtUeberschriftAbsatz
    End Function
#End Region 'Text mit FV formatieren

    Private Sub ErstelltesDok_Oeffnen(ByVal sPfad As String)
        Dim wdApp As Object

        wdApp = Microsoft.VisualBasic.CreateObject("Word.Application")
        wdApp.Visible = True
        wdApp.Documents.Open(sPfad)
        wdApp.ActiveWindow.Activate()
        wdApp = Nothing
    End Sub

    Private Sub btnFertig_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFertig.Click
        Me.Close()
    End Sub
End Class
