﻿Public Class frmKopfFusszeilen
    Private sRefId As String = "rIdhf"
    Private sDateiName As String = "C:\Test\Beispiel26_03_1_Resultat.docx"

    Private Sub btnKopfFusszeilen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnKopfFusszeilen.Click
        Dim iRefCounter As Integer = 1

        Using pkgDoc As WordprocessingDocument = WordprocessingDocument.Open(sDateiName, True)
            Dim mainDocPart As MainDocumentPart = pkgDoc.MainDocumentPart
            Dim sFV_Kopfzeile As String = "Kopfzeile"
            Dim sFV_Fusszeile As String = "Fusszeile"
            'Allfällig vorhandene Kopf-/Fußzeilen entfernen
            Dim headerRefs As IEnumerable(Of HeaderReference) = mainDocPart.Document.Descendants(Of HeaderReference)()
            Dim footerRefs As IEnumerable(Of FooterReference) = mainDocPart.Document.Descendants(Of FooterReference)()
            If headerRefs.Count > 0 Then
                mainDocPart.DeleteParts(mainDocPart.HeaderParts)
                DeleteKopfFusszeilen(mainDocPart, headerRefs.ToArray, headerRefs.Count)
            End If
            If footerRefs.Count > 0 Then
                mainDocPart.DeleteParts(mainDocPart.FooterParts)
                DeleteKopfFusszeilen(mainDocPart, footerRefs.ToArray, footerRefs.Count)
            End If

            'Abschnittswechsel verwalten
            Dim secProps As SectionProperties = mainDocPart.Document.Body.Elements(Of SectionProperties).LastOrDefault
            If secProps Is Nothing Then
                secProps = New SectionProperties()
            End If
            Dim ersteSeiteAnders As TitlePage = secProps.Elements(Of TitlePage).FirstOrDefault()
            If ersteSeiteAnders Is Nothing Then
                ersteSeiteAnders = New TitlePage()
                secProps.Append(ersteSeiteAnders)
            End If

            'Kopf- und Fusszeilenteile erstellen
            Dim Kopfzeile As HeaderReference = New HeaderReference() With {.Id = sRefId & iRefCounter.ToString(), .Type = HeaderFooterValues.Default}
            iRefCounter = KopfzeileErstellen(mainDocPart, iRefCounter, sFV_Kopfzeile)
            secProps.Append(Kopfzeile)

            Dim ErsteKopfzeile As HeaderReference = New HeaderReference() With {.Id = sRefId & iRefCounter.ToString(), .Type = HeaderFooterValues.First}
            iRefCounter = KopfzeileErsteSeiteErstellen(mainDocPart, iRefCounter, sFV_Kopfzeile)
            secProps.Append(ErsteKopfzeile)

            Dim ErsteFusszeile As FooterReference = New FooterReference() With {.Id = sRefId + iRefCounter.ToString(), .Type = HeaderFooterValues.First}
            iRefCounter = FusszeileErstellen(mainDocPart, iRefCounter, sFV_Fusszeile)
            secProps.Append(ErsteFusszeile)

            Dim Fusszeile As FooterReference = New FooterReference() With {.Id = sRefId & iRefCounter.ToString(), .Type = HeaderFooterValues.Default}
            iRefCounter = FusszeileErstellen(mainDocPart, iRefCounter, sFV_Fusszeile)
            secProps.Append(Fusszeile)

            'Formatvorlagen für Kopf- und Fußzeilen erstellen
            Dim fvTeil As StylesPart = mainDocPart.StyleDefinitionsPart()
            If fvTeil Is Nothing Then
                fvTeil = mainDocPart.AddPart(fvTeil)
            End If

            FVKopfFusszeileErstellen(fvTeil, sFV_Kopfzeile, "header", "Standard", "Arial", "8", "4680", "9360")
            FVKopfFusszeileErstellen(fvTeil, sFV_Fusszeile, "footer", "Standard", "Arial", "8", "4680", "9360")
        End Using
    End Sub

    Private Function KopfzeileErstellen(ByVal mainDocPart As MainDocumentPart, ByVal iRefCounter As Integer, ByVal styleID As String) As Integer
        Dim KopfPart As HeaderPart = mainDocPart.AddNewPart(Of HeaderPart)(sRefId & iRefCounter)
        Dim Kopf As Header = New Header(New Paragraph(New ParagraphProperties(New ParagraphStyleId With {.Val = styleID}),
                                                      New Run(New TabChar(), New TabChar(),
                                                              New DocumentFormat.OpenXml.Wordprocessing.Text With {.Text = "Seite ", .Space = SpaceProcessingModeValues.Preserve}),
                                                        New Run(New FieldChar With {.Dirty = False, .FieldCharType = FieldCharValues.Begin}),
                                                        New Run(New FieldCode With {.Text = "Page", .Space = SpaceProcessingModeValues.Preserve}),
                                                        New Run(New FieldChar With {.FieldCharType = FieldCharValues.End}),
                                                      New Run(New DocumentFormat.OpenXml.Wordprocessing.Text With {.Text = " von ", .Space = SpaceProcessingModeValues.Preserve}),
                                                        New Run(New FieldChar With {.Dirty = False, .FieldCharType = FieldCharValues.Begin}),
                                                        New Run(New FieldCode With {.Text = "NumPages", .Space = SpaceProcessingModeValues.Preserve}),
                                                        New Run(New FieldChar With {.FieldCharType = FieldCharValues.Separate}),
                                                        New Run(New FieldChar With {.FieldCharType = FieldCharValues.End})))

        KopfPart.Header = Kopf
        Return iRefCounter + 1
    End Function

    Private Function FusszeileErstellen(ByVal mainDocPart As MainDocumentPart, ByVal iRefCounter As Integer, ByVal styleId As String) As Integer
        Dim FussPart As FooterPart = mainDocPart.AddNewPart(Of FooterPart)(sRefId & iRefCounter)
        Dim Fuss As Footer = New Footer(New Paragraph(New ParagraphProperties(New ParagraphStyleId With {.Val = styleId}),
                                                      New Run(New FieldChar With {.Dirty = False, .FieldCharType = FieldCharValues.Begin}),
                                                        New Run(New FieldCode With {.Text = "FileName \p", .Space = SpaceProcessingModeValues.Preserve}),
                                                        New Run(New FieldChar With {.FieldCharType = FieldCharValues.Separate}), _
                                                        New Run(New Text With {.Text = sDateiName}), _
                                                        New Run(New FieldChar With {.FieldCharType = FieldCharValues.End}), _
                                                        New Run(New TabChar(), New TabChar()), _
                                                    New Run(New FieldChar With {.Dirty = False, .FieldCharType = FieldCharValues.Begin}),
                                                        New Run(New FieldCode With {.Text = "CreateDate \@ yyyy-MM-dd ", .Space = SpaceProcessingModeValues.Preserve}),
                                                        New Run(New FieldChar With {.FieldCharType = FieldCharValues.End})))

        FussPart.Footer = Fuss
        Return iRefCounter + 1
    End Function

    Private Function KopfzeileErsteSeiteErstellen(ByVal mainDocPart As MainDocumentPart, ByVal iRefCounter As Integer, ByVal styleId As String) As Integer
        Dim KopfPart As HeaderPart = mainDocPart.AddNewPart(Of HeaderPart)(sRefId & iRefCounter)
        Dim Kopf As Header = New Header(New Paragraph(New ParagraphProperties(New ParagraphStyleId With {.Val = styleId}),
                                                      New Run(New DocumentFormat.OpenXml.Wordprocessing.Text With {.Text = "", .Space = SpaceProcessingModeValues.Preserve})))
        KopfPart.Header = Kopf
        Return iRefCounter + 1
    End Function

    Private Sub DeleteKopfFusszeilen(ByVal mainDocPart As MainDocumentPart, ByVal hfRefs() As Object, ByVal iAnzahlRefs As Integer)
        Dim hRef As Object, counter As Integer
        For counter = iAnzahlRefs To 1 Step -1 'Each hfRef In hfRefs
            hRef = hfRefs(counter - 1)
            hRef.Remove()
        Next
    End Sub

    Private Sub btnFertig_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFertig.Click
        Me.Close()
    End Sub

    Private Sub FVKopfFusszeileErstellen(ByVal fvTeil As StylesPart, ByVal styleId As String, ByVal styleName As String, _
                                         ByVal styleBasedOn As String, ByVal styleFontName As String, ByVal styleFontSize As String, _
                                         ByVal tabCenterPos As String, ByVal tabRightPos As String)
        Dim styl As Style = New Style(New StyleName With {.Val = styleName}, New BasedOn With {.Val = styleBasedOn}, _
                                      New StyleParagraphProperties(New Tabs( _
                                      New TabStop With {.Position = tabCenterPos, .Val = TabStopValues.Center}, _
                                      New TabStop With {.Position = tabRightPos, .Val = TabStopValues.Right}))) _
                            With {.StyleId = styleId, .Type = StyleValues.Paragraph}
        fvTeil.Styles.Append(styl)
    End Sub

End Class
