﻿Public Class OpenXMLSDK07

    Private Sub btnTabelleErstellen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTabelleErstellen.Click
        Dim sDatenDateiName As String = "C:\Beispiele\Kap26\Tabelle.csv"
        Dim sDocDateiName As String = "C:\Beispiele\Kap26\Beispiel26_04_1.docx"

        'Daten einlesen.
        Dim Daten = DatenEinlesen(sDatenDateiName)
        TabelleDokumentZufuegen(sDocDateiName, Daten)
    End Sub

    Private Function DatenEinlesen(ByVal dateiName As String)
        Dim dataImport = From line As String In System.IO.File.ReadAllLines(dateiName) _
                         Let tr = line.Split(Chr(9))

        Return (dataImport)
    End Function

    Private Sub TabelleDokumentZufuegen(ByVal sDocDateiName As String, ByVal Daten As Object)
        System.Diagnostics.Debug.Print(Daten.GetType().ToString())
        Using pkgDoc As WordprocessingDocument = WordprocessingDocument.Open(sDocDateiName, True)
            Dim partMainDoc As MainDocumentPart = pkgDoc.MainDocumentPart
            Dim b As Body = partMainDoc.Document.Body
            Dim t As Table = TabelleMitEigenschaftenErstellen()
            Dim tr As TableRow = Nothing
            Dim tc As TableCell = Nothing
            Dim iSpalten As Integer
            Dim iCounter As Integer = 0

            'Die Zeilen und Spalten werden von den importierten Daten erstellt
            'Daten ist ein IEnumerable von Datenfelder.
            'Jedes davon enthält den Inhalt einer Zeile als ein Datenfeld von Zeichenketten,
            'das den Inhalt jeder Tabellenzelle umfasst.
            For Each d In Daten
                iCounter = iCounter + 1
                tr = New TableRow()
                'Die Spalten zufügen
                If iCounter = 1 Then
                    'Die erste Zeile übernimmt eine Sonderformatierung von der Tabellenformatvorlage
                    Dim trProps As TableRowProperties = New TableRowProperties( _
                                    New ConditionalFormatStyle With {.Val = "100000000000", .FirstRow = True, _
                                        .LastRow = False, .FirstColumn = False, .LastColumn = False, .OddVerticalBand = False, _
                                        .EvenVerticalBand = False, .OddHorizontalBand = False, .EvenHorizontalBand = False, _
                                        .FirstRowFirstColumn = False, .FirstRowLastColumn = False, .LastRowFirstColumn = False, _
                                        .LastRowLastColumn = False})
                    tr.Append(trProps)
                End If
                iSpalten = d.tr.length - 1
                For i = 0 To iSpalten
                    If iSpalten > 0 Then
                        tc = New TableCell(New TableCellProperties( _
                                           New TableCellWidth With {.Type = TableWidthValues.Dxa}, _
                                           New Paragraph(New Run(New Text _
                                               With {.Text = d.tr(i), .Space = SpaceProcessingModeValues.Preserve}))))
                        'Die zweite Zeile Fett formatieren.
                        If iCounter = 2 Then
                            Dim rProps As RunProperties = New RunProperties(New Bold())
                            tc.Descendants(Of Run).FirstOrDefault().InsertAt(rProps, 0)
                        End If
                    Else
                        'Falls weniger als 4 Spalten (erste Zeile), braucht es ein w:gridSpan Element,
                        'um den Inhalt über die ganze Zeilenbreite zu schreiben.
                        tc = New TableCell(New TableCellProperties( _
                                           New TableCellWidth With {.Width = "9350", .Type = TableWidthValues.Dxa}, _
                                            New GridSpan With {.Val = "4"}), _
                                        New Paragraph(New Run(New Text With {.Text = d.tr(i), .Space = SpaceProcessingModeValues.Preserve})))
                    End If
                    tr.Append(tc)
                Next
                t.Append(tr)
            Next
            Dim tClone As Table = t.CloneNode(True)
            Dim secProps As SectionProperties = b.Elements(Of SectionProperties).LastOrDefault()
            Dim p As Paragraph = New Paragraph()
            secProps.InsertBeforeSelf(tClone)
            secProps.InsertBeforeSelf(p)

            TabellenFVErstellen(partMainDoc)
        End Using
    End Sub

    Private Function TabelleMitEigenschaftenErstellen() As Table
        Dim t As Table = New Table(New TableProperties(New TableStyle With {.Val = "MeineTabelleFV"}, _
                                                       New TableLayout With {.Type = TableLayoutValues.Fixed}, _
                                                    New TableLook With {.Val = "0400", .NoVerticalBand = "1", _
                                                       .NoHorizontalBand = "0", .LastColumn = "0", _
                                                       .FirstColumn = "0", .LastRow = "0", .FirstRow = "1"}, _
                                                   New TableWidth With {.Width = "9350", .Type = TableWidthUnitValues.Dxa}), _
                                    New TableGrid(New GridColumn With {.Width = "1776"}, _
                                                  New GridColumn With {.Width = "4002"}, _
                                                  New GridColumn With {.Width = "1475"}, _
                                                  New GridColumn With {.Width = "2097"}))
        Return t
    End Function

    Private Sub TabellenFVErstellen(ByVal partMainDoc As MainDocumentPart)
        Dim FV As Styles = partMainDoc.StyleDefinitionsPart.Styles
        Dim styl As Style = New Style(New Name With {.Val = "MeineTabelleFV"}, _
                                      New BasedOn With {.Val = "NormaleTabelle"}, _
                            New StyleParagraphProperties(New Justification With {.Val = JustificationValues.Left}, _
                                                         New SpacingBetweenLines With {.After = "0"}), _
                            New StyleRunProperties(New RunFonts With {.Ascii = "Times New Roman"}, _
                                                   New FontSize With {.Val = "24"}), _
                            New StyleTableProperties(New TableIndentation With {.Width = "0", .Type = TableWidthUnitValues.Dxa}, _
                                                New TableBorders(New TopBorder With {.Val = BorderValues.Single, .Size = 4, .Space = 0, .Color = "auto"}, _
                                                                New BottomBorder With {.Val = BorderValues.Single, .Size = 4, .Space = 0, .Color = "auto"}, _
                                                                New LeftBorder With {.Val = BorderValues.Single, .Size = 4, .Space = 0, .Color = "auto"}, _
                                                                New RightBorder With {.Val = BorderValues.Single, .Size = 4, .Space = 0, .Color = "auto"}, _
                                                                New InsideHorizontalBorder With {.Val = BorderValues.Single, .Size = 4, .Space = 0, .Color = "auto"}, _
                                                                New InsideVerticalBorder With {.Val = BorderValues.Single, .Size = 4, .Space = 0, .Color = "auto"}), _
                                                New TableCellMarginDefault(New TableCellLeftMargin With {.Width = 108, .Type = TableWidthValues.Dxa}, _
                                                                    New TableCellRightMargin With {.Width = 108, .Type = TableWidthValues.Dxa}, _
                                                                    New TopMargin With {.Width = "0", .Type = TableWidthUnitValues.Dxa}, _
                                                                    New BottomMargin With {.Width = "0", .Type = TableWidthUnitValues.Dxa})), _
                            New TableStyleProperties(New StyleParagraphProperties(New Justification With {.Val = JustificationValues.Center}), _
                                                     New RunPropertiesBaseStyle(New Bold, New SmallCaps, New Caps With {.Val = "0"}), _
                                                     New TableProperties, New TableCellProperties(New Shading With {.Val = ShadingPatternValues.Clear, .Color = "auto", .Fill = "DDDDDD"})) _
                                With {.Type = TableStyleOverrideValues.FirstRow}) _
                            With {.StyleId = "MeineTabelleFV", .Type = StyleValues.Table, .CustomStyle = "true"}

        FV.Append(styl)
    End Sub

    Private Sub btnFertig_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFertig.Click
        Me.Close()
    End Sub


End Class
